/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, markType, INotifyPropertyChanged_$type, PropertyChangedEventArgs, runOn, delegateCombine, typeCast, delegateRemove, fromEn, fromEnum, enumGetBox, Number_$type, String_$type, typeGetValue } from "igniteui-react-core";
import { RenderingContext } from "igniteui-react-core";
import { FontInfo } from "igniteui-react-core";
import { DOMExecutionContext } from "igniteui-react-core";
import { CanvasViewRenderer } from "igniteui-react-core";
import { NativeUIComponent } from "igniteui-react-core";
import { Size } from "igniteui-react-core";
import { NativeUI } from "igniteui-react-core";
import { FontUtil } from "igniteui-react-core";
import { SRProvider } from "igniteui-react-core";
import { PropertyEditorPropertyDescriptionCollection } from "./PropertyEditorPropertyDescriptionCollection";
import { List$1 } from "igniteui-react-core";
import { ObservableCollection$1 } from "igniteui-react-core";
import { PropertyEditorPanelColumnDefinition } from "./PropertyEditorPanelColumnDefinition";
import { ComponentRenderer } from "igniteui-react-core";
import { DeviceUtils } from "igniteui-react-core";
import { Dictionary$2 } from "igniteui-react-core";
import { NativeUIInputsFactory } from "igniteui-react-core";
import { PropertyEditorPropertyDescription } from "./PropertyEditorPropertyDescription";
import { LocalDataSource } from "igniteui-react-core";
import { HorizontalPropertyEditorPanelDataSource } from "./HorizontalPropertyEditorPanelDataSource";
import { PropertyEditorDataSource } from "./PropertyEditorDataSource";
import { HashSet$1 } from "igniteui-react-core";
import { PropertyEditorValueType_$type } from "./PropertyEditorValueType";
import { PropertyEditorTreeTransformer } from "./PropertyEditorTreeTransformer";
import { BrushUtil } from "igniteui-react-core";
import { Thickness } from "igniteui-react-core";
import { truncate, isNaN_, tryParseNumber } from "igniteui-react-core";
import { stringIsNullOrEmpty, stringContains, stringReplace } from "igniteui-react-core";
import { stringSplit } from "igniteui-react-core";
import { tryParseBool } from "igniteui-react-core";
/**
 * @hidden
 */
export let PropertyEditorPanelView = /*@__PURE__*/ (() => {
    class PropertyEditorPanelView extends Base {
        constructor() {
            super();
            this.n = null;
            this.m = null;
            this.a = null;
            this.i = null;
            this.l = null;
            this.e = null;
            this.k = null;
            this.b = ((() => {
                let $ret = new FontInfo();
                $ret.q = "Verdana";
                $ret.f = 13;
                $ret.t = "Normal";
                $ret.v = "Normal";
                $ret.r = "Normal";
                return $ret;
            })());
            this.aa = new Size();
            this.c = null;
            this._gridExternal = null;
            this.f = false;
            this.j = null;
        }
        p() {
            return this.i;
        }
        v() {
        }
        t(a) {
            if (a == null) {
                this.i = null;
                return;
            }
            this.a.j = new DOMExecutionContext(a);
            this.i = a;
            this.l = this.i.createElement("canvas");
            this.e = new RenderingContext(new CanvasViewRenderer(), this.i.get2DCanvasContext(this.l));
            this.k = this.i.createElement("div");
            this.y();
            NativeUIComponent.at(this.p(), 7, (b) => {
                let c = b;
                this.a.dj(c, this.n);
                this.i.append(c.an);
            });
            let b = Math.round(a.rootWrapper.width());
            let c = Math.round(a.rootWrapper.height());
            this.i.rootWrapper.setStyleProperty("position", "relative");
        }
        y() {
        }
        x() {
            if (this.i != null) {
            }
        }
        s() {
            if (this.i == null) {
                return;
            }
            let a = this.i.rootWrapper.width();
            let b = this.i.rootWrapper.height();
            this.aa = new Size(1, a, b);
            if (this.a.v != null) {
                this.a.d4();
            }
        }
        z() {
            let a = this.i;
            if (null == a) {
                return;
            }
            let b = a.rootWrapper;
            if (null != b) {
                NativeUI.q(b, this.a.eb);
                NativeUI.m(b, this.a.d8);
            }
        }
        d() {
            return this.b;
        }
        u() {
        }
        w() {
        }
        r() {
            let a = this.a.ec();
            if (a.height > 0) {
                this.i.rootWrapper.setStyleProperty("min-height", a.height + "px");
            }
        }
        g() {
            return this.aa.width;
        }
        h(a) {
            this.c = this.a.u();
            return FontUtil.measureStringWidth(a, this.c, this.e);
        }
        q(a, b) {
            if (this.j == null) {
                this.j = this.i.createElement("div");
            }
            b(this.j.getNativeElement());
        }
    }
    PropertyEditorPanelView.$t = /*@__PURE__*/ markType(PropertyEditorPanelView, 'PropertyEditorPanelView');
    return PropertyEditorPanelView;
})();
/**
 * @hidden
 */
export let PropertyEditorPanel = /*@__PURE__*/ (() => {
    class PropertyEditorPanel extends Base {
        get x() {
            if (this.w == null) {
                this.w = new SRProvider(this.l.i);
                this.w.cb("Layouts");
            }
            return this.w;
        }
        constructor() {
            super();
            this.l = null;
            this.v = null;
            this.r = null;
            this.y = false;
            this.z = false;
            this.w = null;
            this.propertyChanged = null;
            this.af = false;
            this.n = null;
            this.o = new PropertyEditorPropertyDescriptionCollection();
            this.bl = -1;
            this.aq = DeviceUtils.g(38);
            this.s = null;
            this.bs = null;
            this.c = null;
            this.an = null;
            this.j = null;
            this.ae = false;
            this.ap = null;
            this.bk = -1;
            this.bu = null;
            this.ad = true;
            this.am = new Dictionary$2(PropertyEditorPanelColumnDefinition.$, Number_$type, 0);
            this.f = null;
            this.g = null;
            this.d = null;
            this.br = null;
            this.bv = null;
            this.aa = false;
            this.ac = false;
            this.ab = false;
            this.d6 = PropertyEditorPanel.d9;
            this.d7 = PropertyEditorPanel.ea;
            this.bp = 0;
            this.bm = -1;
            this.k = null;
            NativeUIInputsFactory.n();
            this.ap = new ObservableCollection$1(PropertyEditorPanelColumnDefinition.$, 0);
            let a = new PropertyEditorPanelView();
            a.a = this;
            this.l = a;
            this.l.v();
            let b = this.properties;
            b.collectionChanged = delegateCombine(b.collectionChanged, runOn(this, this.dz));
        }
        dz(a, b) {
            if (b.oldItems != null) {
                for (let c of fromEn(b.oldItems)) {
                    if (typeCast(INotifyPropertyChanged_$type, c) !== null) {
                        let d = c;
                        d.propertyChanged = delegateRemove(d.propertyChanged, runOn(this, this.dl));
                    }
                }
            }
            if (b.newItems != null) {
                for (let e of fromEn(b.newItems)) {
                    if (typeCast(INotifyPropertyChanged_$type, e) !== null) {
                        let f = e;
                        f.propertyChanged = delegateCombine(f.propertyChanged, runOn(this, this.dl));
                    }
                }
            }
            this.aj();
            if (this.properties.count > 0 && this.actualProperties != this.properties) {
                this.actualProperties = this.properties;
            }
            this.dv();
        }
        dv() {
            if (!this.af) {
                if (this.v != null) {
                    this.d4();
                }
            }
        }
        dl(a, b) {
            if (!this.af) {
                this.aj();
                if (this.v != null) {
                    this.d4();
                }
            }
        }
        notifySizeChanged() {
            this.l.s();
        }
        dj(a, b) {
            this.v = a;
            if (null != this.v) {
                if (this.actualProperties != null) {
                    if (this.ag) {
                        if (this.actualProperties != null && !(typeCast(HorizontalPropertyEditorPanelDataSource.$, this.actualProperties) !== null)) {
                            this.actualProperties = new HorizontalPropertyEditorPanelDataSource(this.actualProperties);
                        }
                    }
                    else {
                        if (typeCast(HorizontalPropertyEditorPanelDataSource.$, this.actualProperties) !== null) {
                            let c = this.actualProperties;
                            this.actualProperties = c.ae;
                        }
                    }
                    this.bs = this.actualProperties;
                    let d = this.actualProperties;
                    d = this.actualProperties.toArray();
                    let e = new LocalDataSource();
                    e.dataSource = d;
                    this.c = e;
                    this.cf();
                }
                if (this.actualProperties != null) {
                    this.d4();
                }
            }
        }
        destroy() {
            this.provideContainer(null);
        }
        provideContainer(a) {
            this.l.t(a);
        }
        du(a) {
        }
        get actualProperties() {
            return this.n;
        }
        set actualProperties(a) {
            let b = this.n;
            this.n = a;
            if (b != this.n) {
                this.dw("ActualProperties", b, this.n);
            }
        }
        get properties() {
            return this.o;
        }
        set properties(a) {
            let b = this.o;
            this.o = a;
            if (b != this.o) {
                this.dw("Properties", b, this.o);
            }
        }
        get bq() {
            return this.bl;
        }
        set bq(a) {
            let b = this.bl;
            this.bl = a;
            if (b != this.bl) {
                this.dw("RowHeight", b, this.bl);
            }
        }
        get ar() {
            return this.aq;
        }
        set ar(a) {
            this.aq = a;
        }
        get t() {
            return this.s;
        }
        set t(a) {
            let b = this.s;
            this.s = a;
            if (b != this.s) {
                this.dw("CellTextStyle", b, this.s);
            }
        }
        u() {
            if (this.t == null) {
                return this.l.d();
            }
            return this.t;
        }
        dw(a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs(a));
            }
            this.d0(a, b, c);
        }
        d0(a, b, c) {
            switch (a) {
                case "DescriptionType":
                    if (this.b3 == null) {
                        if (this.properties == null) {
                            this.actualProperties = null;
                        }
                    }
                    if (this.b3 != null) {
                        if (this.k == null) {
                            this.k = new PropertyEditorDataSource();
                        }
                        this.k.n = this.b3;
                    }
                    if (this.properties == null || this.properties.count == 0) {
                        if (this.k.h != null) {
                            this.actualProperties = this.k.h;
                        }
                    }
                    else {
                        if (this.properties != null && this.properties.count > 0) {
                            this.aj();
                        }
                    }
                    break;
                case "ComponentRenderer":
                    if (b != null) {
                        b.removeTargetPropertyUpdatingListener(runOn(this, this.al));
                    }
                    if (b != c) {
                        this.ad = true;
                    }
                    if (this.e == null) {
                        this.h = this.i;
                    }
                    else {
                        this.h = this.e.context;
                    }
                    break;
                case "Target":
                    if (ComponentRenderer.defaultInstance != null && this.e == null) {
                        this.e = ComponentRenderer.defaultInstance;
                    }
                    break;
                case "DescriptionContext":
                    if (this.e == null) {
                        this.h = c;
                    }
                    break;
                case "ActualContext":
                    if (this.h == null) {
                        if (this.properties == null) {
                            this.actualProperties = null;
                        }
                    }
                    if (this.h != null) {
                        if (this.k == null) {
                            this.k = new PropertyEditorDataSource();
                        }
                        this.k.b = this.h;
                    }
                    if (this.properties == null || this.properties.count == 0) {
                        if (this.k.h != null) {
                            this.actualProperties = this.k.h;
                        }
                    }
                    else {
                        if (this.properties != null && this.properties.count > 0) {
                            this.aj();
                        }
                    }
                    break;
                case "Properties":
                    this.actualProperties = this.properties;
                    break;
                case "IsWrappingEnabled":
                    this.d4();
                    break;
                case "IsHorizontal":
                    if (this.ag) {
                        this.bk = -1;
                        if (this.actualProperties != null && !(typeCast(HorizontalPropertyEditorPanelDataSource.$, this.actualProperties) !== null)) {
                            this.actualProperties = new HorizontalPropertyEditorPanelDataSource(this.actualProperties);
                        }
                    }
                    else {
                        if (typeCast(HorizontalPropertyEditorPanelDataSource.$, this.actualProperties) !== null) {
                            let d = this.actualProperties;
                            this.actualProperties = d.ae;
                        }
                    }
                    break;
                case "ActualProperties":
                    if (this.ag) {
                        if (this.actualProperties != null && !(typeCast(HorizontalPropertyEditorPanelDataSource.$, this.actualProperties) !== null)) {
                            this.actualProperties = new HorizontalPropertyEditorPanelDataSource(this.actualProperties);
                        }
                    }
                    else {
                        if (typeCast(HorizontalPropertyEditorPanelDataSource.$, this.actualProperties) !== null) {
                            let e = this.actualProperties;
                            this.actualProperties = e.ae;
                        }
                    }
                    if (this.v != null) {
                        let f = this.bs != this.actualProperties;
                        if (this.ag) {
                            if (this.actualProperties != null && !(typeCast(HorizontalPropertyEditorPanelDataSource.$, this.actualProperties) !== null)) {
                                this.actualProperties = new HorizontalPropertyEditorPanelDataSource(this.actualProperties);
                            }
                        }
                        else {
                            if (typeCast(HorizontalPropertyEditorPanelDataSource.$, this.actualProperties) !== null) {
                                let g = this.actualProperties;
                                this.actualProperties = g.ae;
                            }
                        }
                        this.bs = this.actualProperties;
                        let h = this.actualProperties;
                        h = this.actualProperties.toArray();
                        let i = new LocalDataSource();
                        i.dataSource = h;
                        this.c = i;
                        this.cf();
                        if (this.c != null) {
                            let j = this.c;
                            j.schemaChanged = delegateCombine(j.schemaChanged, runOn(this, this.dy));
                        }
                        if (f) {
                            this.d4();
                        }
                    }
                    break;
                case "RowHeight":
                    if (this.v != null) {
                        this.ar = this.bq;
                    }
                    break;
                case "CellTextStyle":
                    this.d2();
                    break;
                case "BackgroundColor":
                case "TextColor":
                    this.d2();
                    break;
            }
        }
        aj() {
            let a = this.af;
            this.af = true;
            let b = false;
            for (let c of fromEnum(this.properties)) {
                let d = c.an;
                if (this.k != null) {
                    let e = this.k.e(d, false);
                    if (e != null) {
                        if (c.r(e)) {
                            b = true;
                        }
                    }
                }
            }
            if (b) {
                this.d4();
            }
            else if (this.v != null) {
                this.d2();
            }
            this.af = a;
            return b;
        }
        d2() {
            if (!this.ae && this.j != null) {
                this.ae = true;
                this.j.enqueueAction(runOn(this, this.ck));
            }
        }
        ck() {
            this.ae = false;
            if (this.an == null) {
                this.an = new List$1(List$1.$.specialize(NativeUIComponent.$), 0);
            }
            if (this.c == null) {
                return;
            }
            let a = this.c.actualCount;
            for (let b = 0; b < a; b++) {
                let c = b;
                let d = this.c.getItemAtIndex(b);
                if (this.v.by < c + 1) {
                    this.v.b1(c, 1, this.ar);
                }
                else {
                    this.v.b9(c, 1, this.ar);
                }
                if (this.an.count < c + 1) {
                    this.an.add(new List$1(NativeUIComponent.$, 0));
                }
                let e = this.an._inner[c];
                for (let f = 0; f < this.ap.count; f++) {
                    let g = this.ap._inner[f];
                    if (e.count < f + 1) {
                        NativeUIComponent.ax(this.l.p(), 0, (h) => {
                            let i = h;
                            i.h = 1;
                            if (g.a == 0) {
                                i.f = 2;
                            }
                            i.bf = new Thickness(1, 5, 5, 5, 0);
                            this.v.bl(i);
                            this.v.b7(i, c);
                            this.v.b6(i, f);
                            e.add(i);
                        });
                    }
                    if (this.v.bv < f + 1) {
                        this.v.bz(f, 1, g.h);
                    }
                    else {
                        this.v.b8(f, 1, g.h);
                    }
                    let h = e._inner[f];
                    let i = "PropertyPath";
                    if (g.a == 1) {
                        i = "ValueType";
                    }
                    let j = h;
                    let k = this.m(g, c, d);
                    let l = null;
                    if (k != null) {
                        l = this.c.getItemProperty(k, i);
                        l = g.i(l, c, d);
                        if (l != null) {
                            h = g.e(h, c, d);
                        }
                    }
                    if (l == null) {
                        let m = h;
                        m.bq = null;
                    }
                }
            }
            let n = new HashSet$1(NativeUIComponent.$, 0);
            for (let o = this.v.bk - 1; o >= 0; o--) {
                let p = this.v.bj(o);
                let q = this.v.bx(p);
                let r = this.v.bw(p);
                if ((q + 1) > a || (r + 1) > this.ap.count) {
                    n.add_1(p);
                }
            }
            for (let s = this.v.bk - 1; s >= 0; s--) {
                let t = this.v.bj(s);
                if (n.contains(t)) {
                    this.v.bo(s);
                }
            }
            for (let u = this.an.count - 1; u >= 0; u--) {
                for (let v = this.an._inner[u].count - 1; v >= 0; v--) {
                    let w = this.an._inner[u]._inner[v];
                    if (n.contains(w)) {
                        this.an._inner[u].removeAt(v);
                    }
                }
                if (this.an._inner[u].count == 0) {
                    this.an.removeAt(u);
                }
            }
            while (this.v.by > a) {
                this.v.b5(this.v.by - 1);
            }
            while (this.v.bv > this.ap.count) {
                this.v.b4(this.v.bv - 1);
            }
        }
        dy(a, b) {
            this.z = true;
            this.cf();
            this.z = false;
        }
        d4() {
            if (this.v == null) {
                return;
            }
            this.am.clear();
            this.ap.clear();
            let a = this.bq == -1 ? 38 : this.bq;
            let b = this.d8;
            let c = this.u();
            if (this.ag) {
                this.ch();
            }
            else {
                let d = new PropertyEditorPanelColumnDefinition();
                d.b = 0;
                d.f = 10;
                d.g = 5;
                d.a = 0;
                d.dataBinding = delegateCombine(d.dataBinding, runOn(this, this.dn));
                d.cellUpdating = delegateCombine(d.cellUpdating, runOn(this, this.dm));
                d.j = "PropertyPath";
                this.ap.add(d);
                let e = new PropertyEditorPanelColumnDefinition();
                e.b = 1;
                e.a = 1;
                e.f = 5;
                e.g = 5;
                e.dataBinding = delegateCombine(e.dataBinding, runOn(this, this.cm));
                e.cellUpdating = delegateCombine(e.cellUpdating, runOn(this, this.cl));
                e.j = "ValueType";
                this.ap.add(e);
            }
            this.d2();
        }
        ch() {
            if (this.actualProperties == null) {
                return;
            }
            let a = this.actualProperties.ae;
            let b = a.count;
            let c = new List$1(PropertyEditorPanelColumnDefinition.$, 0);
            let d = this.bn(a, b, c, 0x7FFFFFFF);
            for (let e = 0; e < c.count; e++) {
                this.ap.add(c._inner[e]);
            }
            this.bp = d;
            let f = this.actualProperties;
            let g = this.bk;
            f.clear();
            for (let h = 0; h < this.bp; h++) {
                f.add(new PropertyEditorPropertyDescription());
            }
            let i = this.actualProperties.toArray();
            let j = new LocalDataSource();
            j.dataSource = i;
            this.c = j;
            if (f.count != g) {
                this.bk = f.count;
                this.d2();
                this.l.r();
            }
        }
        ec() {
            if (this.ag && this.v != null && this.c != null) {
                let a = this.ar;
                let b = this.actualProperties;
                return new Size(1, 0, b.count * a);
            }
            else {
                return new Size(1, 0, 0);
            }
        }
        bn(a, b, c, d) {
            let e = 0;
            let f = 0;
            let g = 0;
            let h = this.l.g();
            h -= 5;
            if (!this.ai) {
                h = 1.7976931348623157E+308;
            }
            let i = 0;
            let j = h;
            for (let k = 0; k < b; k++) {
                let l = a.item(k);
                let m = this.ba(l);
                let n = this.a6(l);
                if ((i + m + n > h && g > 0) || g >= d) {
                    if (f != 0 && g < d && d > 2) {
                        let o = c._inner[g];
                        let p = c._inner[g + 1];
                        o.h = m;
                        p.h = n;
                        this.d3(h, c);
                        if (c.count == 0) {
                            return 0;
                        }
                        return this.bn(a, b, c, c.count);
                    }
                    d = Math.max(Math.min(d, g), 2);
                    f++;
                    let q = h - i;
                    if (q < j) {
                        j = q;
                    }
                    i = 0;
                    g = 0;
                }
                let r = this.b6(l);
                if (c.count <= g) {
                    let s = new PropertyEditorPanelColumnDefinition();
                    s.b = 0;
                    s.a = 0;
                    s.f = 10;
                    s.g = 5;
                    s.h = m;
                    s.dataBinding = delegateCombine(s.dataBinding, runOn(this, this.dn));
                    s.cellUpdating = delegateCombine(s.cellUpdating, runOn(this, this.dm));
                    s.j = "PropertyName_" + k;
                    c.add(s);
                    this.am.item(s, c.count - 1);
                    g++;
                }
                else {
                    let t = c._inner[g];
                    if (m > t.h) {
                        let u = m - t.h;
                        t.h = m;
                        if (u > j && d > 2) {
                            this.d3(h, c);
                            if (c.count == 0) {
                                return 0;
                            }
                            return this.bn(a, b, c, c.count);
                        }
                        else {
                            j -= u;
                            if (j < 0) {
                                j = 0;
                            }
                            g++;
                        }
                    }
                    else {
                        m = t.h;
                        g++;
                    }
                }
                if (c.count <= g) {
                    let v = new PropertyEditorPanelColumnDefinition();
                    v.b = 1;
                    v.a = 1;
                    v.j = "ValueType_" + k;
                    v.f = 5;
                    v.g = 5;
                    v.dataBinding = delegateCombine(v.dataBinding, runOn(this, this.cm));
                    v.h = n;
                    v.cellUpdating = delegateCombine(v.cellUpdating, runOn(this, this.cl));
                    c.add(v);
                    this.am.item(v, c.count - 1);
                    g++;
                }
                else {
                    let w = c._inner[g];
                    if (n > w.h) {
                        let x = n - w.h;
                        w.h = n;
                        if (x > j && d > 2) {
                            this.d3(h, c);
                            if (c.count == 0) {
                                return 0;
                            }
                            return this.bn(a, b, c, c.count);
                        }
                        else {
                            j -= x;
                            if (j < 0) {
                                j = 0;
                            }
                            g++;
                        }
                    }
                    else {
                        n = w.h;
                        g++;
                    }
                }
                i += m + n;
            }
            return f + 1;
        }
        d3(a, b) {
            let c = 0;
            for (let d of fromEnum(b)) {
                c += d.h;
            }
            while (c > a) {
                if (b.count < 1) {
                    return;
                }
                if (b._inner[b.count - 1].b == 1) {
                    c -= b._inner[b.count - 1].h;
                    c -= b._inner[b.count - 2].h;
                    b.removeAt(b.count - 1);
                    b.removeAt(b.count - 1);
                }
                else {
                    c -= b._inner[b.count - 1].h;
                    b.removeAt(b.count - 1);
                }
            }
        }
        cm(a, b) {
            let c = a;
            let d = this.m(c, b.a, b.c);
            b.b = enumGetBox(PropertyEditorValueType_$type, d != null ? d.p : 0);
        }
        dn(a, b) {
            let c = a;
            let d = this.m(c, b.a, b.c);
            if (d == null) {
                b.b = null;
                return;
            }
            b.b = d.al != null ? d.al : d.an;
        }
        a6(a) {
            if (!isNaN_(a.y)) {
                return a.y;
            }
            switch (a.p) {
                case 10: return this.as(a);
                case 7: return this.at(a);
                case 4: return this.av(a);
                case 6: return this.au(a);
                case 23: return this.a4(a);
                case 9: return this.ay(a);
                case 5: return this.a0(a);
                case 14: return this.az(a);
                case 18: return this.a1(a);
                case 3: return this.a2(a);
                case 15: return this.a7(a);
                case 17: return this.a8(a);
                case 16: return this.bb(a);
                case 1: return this.bc(a);
                case 11: return this.bd(a);
                case 13: return this.be(a);
                case 12: return this.bf(a);
                case 2: return this.bh(a);
                case 8: return this.bi(a);
                case 19: return this.bj(a);
                case 0: return this.a9(a);
                case 20: return this.aw(a);
                case 21: return this.bg(a);
            }
            return 100;
        }
        bj(a) {
            return this.a9(a);
        }
        a9(a) {
            return 175;
        }
        aw(a) {
            if (a.af != null) {
                return Math.max(100, this.l.h(a.af.toString()) + 30);
            }
            return 80;
        }
        bg(a) {
            return 175;
        }
        bi(a) {
            return this.aw(a);
        }
        bh(a) {
            return this.a9(a);
        }
        bf(a) {
            return this.a9(a);
        }
        be(a) {
            return this.a9(a);
        }
        bd(a) {
            return this.a9(a);
        }
        bc(a) {
            return this.a9(a);
        }
        bb(a) {
            return this.aw(a);
        }
        a8(a) {
            return this.aw(a);
        }
        a7(a) {
            return this.a5(a);
        }
        a5(a) {
            return this.a9(a);
        }
        a2(a) {
            return this.a3(a);
        }
        a3(a) {
            return this.a9(a);
        }
        a1(a) {
            return this.aw(a);
        }
        az(a) {
            return this.aw(a);
        }
        a0(a) {
            return this.a9(a);
        }
        ay(a) {
            return this.aw(a);
        }
        au(a) {
            return this.aw(a);
        }
        a4(a) {
            return this.a9(a);
        }
        av(a) {
            return this.a9(a);
        }
        at(a) {
            return this.ax(a);
        }
        ax(a) {
            return 50;
        }
        as(a) {
            return this.aw(a);
        }
        ba(a) {
            if (!isNaN_(a.z)) {
                return a.z;
            }
            return this.l.h(this.b6(a)) + 17;
        }
        b6(a) {
            return a.al != null ? a.al : a.an;
        }
        dm(a, b) {
            let c = a;
            let d = this.m(c, b.b, b.c);
            this.c9(c, b);
        }
        cl(a, b) {
            let c = a;
            let d = this.m(c, b.b, b.c);
            let e = d != null ? d.p : 0;
            switch (e) {
                case 10:
                    this.ct(c, b);
                    break;
                case 7:
                    this.cu(c, b);
                    break;
                case 4:
                    this.cw(c, b);
                    break;
                case 6:
                    this.cv(c, b);
                    break;
                case 23:
                    this.c4(c, b);
                    break;
                case 9:
                    this.cy(c, b);
                    break;
                case 5:
                    this.c0(c, b);
                    break;
                case 14:
                    this.cz(c, b);
                    break;
                case 18:
                    this.c1(c, b);
                    break;
                case 3:
                    this.c2(c, b);
                    break;
                case 15:
                    this.c6(c, b);
                    break;
                case 17:
                    this.c7(c, b);
                    break;
                case 16:
                    this.da(c, b);
                    break;
                case 1:
                    this.db(c, b);
                    break;
                case 11:
                    this.dc(c, b);
                    break;
                case 13:
                    this.dd(c, b);
                    break;
                case 12:
                    this.de(c, b);
                    break;
                case 2:
                    this.dg(c, b);
                    break;
                case 8:
                    this.dh(c, b);
                    break;
                case 19:
                    this.di(c, b);
                    break;
                case 20:
                    this.cx(c, b);
                    break;
                case 21:
                    this.df(c, b);
                    break;
                case 0: break;
            }
        }
        di(a, b) {
            this.c8(a, b);
        }
        dh(a, b) {
        }
        dg(a, b) {
            this.c8(a, b);
        }
        de(a, b) {
            this.c8(a, b);
        }
        dd(a, b) {
            this.c8(a, b);
        }
        dc(a, b) {
            this.c8(a, b);
        }
        db(a, b) {
            this.c8(a, b);
        }
        c9(a, b) {
            this.cr(b, (c, d) => {
                c.bi = this.u();
                c.h = 1;
                let e = this.m(a, b.b, b.c);
                c.ao = e;
                c.bk = this.b6(e);
            });
        }
        c8(a, b) {
            this.cq(b, (c, d) => {
                c.h = 1;
                c.bo = 1;
                c.bl = 2;
                let e = this.m(a, b.b, b.c);
                c.ao = e;
                c.bs = (e.af != null ? e.af.toString() : "");
                if (d) {
                    c.bn = runOn(this, this.dk);
                }
            });
        }
        cr(a, b) {
            let c = a.a;
            let d = c.bq;
            let e = false;
            if (d == null || d.e != 3) {
                e = true;
                NativeUIComponent.at(this.l.p(), 3, (f) => {
                    c.bq = f;
                    b(f, e);
                });
                return;
            }
            b(d, e);
        }
        cq(a, b) {
            let c = a.a;
            let d = c.bq;
            let e = false;
            if (d == null || d.e != 2) {
                e = true;
                NativeUIComponent.at(this.l.p(), 2, (f) => {
                    c.bq = f;
                    b(f, e);
                });
                return;
            }
            b(d, e);
        }
        cn(a, b) {
            let c = a.a;
            let d = c.bq;
            let e = false;
            if (d == null || d.e != 1) {
                e = true;
                NativeUIComponent.at(this.l.p(), 1, (f) => {
                    c.bq = f;
                    b(f, e);
                });
                return;
            }
            b(d, e);
        }
        cs(a, b) {
            let c = a.a;
            let d = c.bq;
            let e = false;
            if (d == null || d.e != 5) {
                e = true;
                NativeUIComponent.at(this.l.p(), 5, (f) => {
                    c.bq = f;
                    b(f, e);
                });
                return;
            }
            b(d, e);
        }
        cp(a, b) {
            let c = a.a;
            let d = c.bq;
            let e = false;
            if (d == null || d.e != 4) {
                e = true;
                NativeUIComponent.at(this.l.p(), 4, (f) => {
                    c.bq = f;
                    b(f, e);
                });
                return;
            }
            b(d, e);
        }
        co(a, b) {
            let c = a.a;
            let d = c.bq;
            let e = false;
            if (d == null || d.e != 6) {
                e = true;
                NativeUIComponent.at(this.l.p(), 6, (f) => {
                    c.bq = f;
                    b(f, e);
                });
                return;
            }
            b(d, e);
        }
        cx(a, b) {
            this.cn(b, (c, d) => {
                c.h = 1;
                if (c.bn != 2) {
                    c.bn = 2;
                }
                let e = this.m(a, b.b, b.c);
                c.ao = e;
                let f = e.af;
                if (typeof e.af === 'number' || typeof e.af === 'number') {
                    f = e.af.toString();
                }
                c.bw = f;
                if (d) {
                    c.bk = runOn(this, this.ce);
                }
            });
        }
        df(a, b) {
            this.cs(b, (c, d) => {
                c.h = 1;
                let e = this.m(a, b.b, b.c);
                c.ao = e;
                let f = e.af;
                if (typeof e.af === 'number' || typeof e.af === 'number') {
                    f = e.af;
                }
                if (typeof e.af === 'string') {
                    let g = 0;
                    let h = tryParseNumber(f, g);
                    g = h.p1;
                    f = g;
                }
                if (f == null) {
                    f = 0;
                }
                c.bp = f;
                if (!isNaN_(e.ab)) {
                    c.bn = e.ab;
                }
                else {
                    c.bn = 0;
                }
                if (!isNaN_(e.aa)) {
                    c.bm = e.aa;
                }
                else {
                    c.bm = 100;
                }
                if (!isNaN_(e.ac)) {
                    c.bo = e.ac;
                }
                else {
                    c.bo = 1;
                }
                if (d) {
                    c.bl = runOn(this, this.d5);
                }
            });
        }
        d5(a, b) {
            let c = a;
            let d = c.ao;
            this.af = true;
            d.af = c.bp;
            this.af = false;
            this.dx(d);
        }
        c5(a, b) {
            this.cp(b, (c, d) => {
                c.h = 1;
                if (c.bi != 2) {
                    c.bi = 2;
                }
                let e = this.m(a, b.b, b.c);
                if (c.ao != e) {
                    {
                        c.bk = null;
                    }
                    c.ao = e;
                    c.bm = null;
                    c.bl = this.b(this.a(e));
                    if (e.af != c.bm) {
                        if (typeof e.af === 'number' || typeof e.af === 'number') {
                            c.bm = e.af.toString();
                        }
                        else {
                            c.bm = e.af;
                        }
                    }
                    {
                        c.bk = runOn(this, this.ci);
                    }
                }
                else {
                    if (e.af != c.bm) {
                        if (typeof e.af === 'number' || typeof e.af === 'number') {
                            c.bm = e.af.toString();
                        }
                        else {
                            c.bm = e.af;
                        }
                    }
                }
                if (d) {
                    if (c.bk == null) {
                        c.bk = runOn(this, this.ci);
                    }
                    c.a6 = BrushUtil.h(255, 255, 255, 255);
                }
            });
        }
        b(a) {
            return a;
        }
        a(a) {
            return a.c;
        }
        ci(a, b) {
            let c = a;
            let d = c.ao;
            this.af = true;
            d.af = c.bm;
            d.ao();
            this.af = false;
            this.dx(d);
        }
        dk(a, b) {
            let c = a;
            let d = c.ao;
            this.af = true;
            if (d.p == 1) {
                let e = 0;
                let f = tryParseNumber(c.bs, e);
                e = f.p1;
                d.af = e;
            }
            else if (d.p == 23) {
                if (c.bs != null) {
                    let g = c.bs.split(' ');
                    let h = new List$1(Number_$type, 0);
                    for (let j = 0; j < g.length; j++) {
                        let i = g[j];
                        if (!stringIsNullOrEmpty(i)) {
                            let k = 0;
                            if (((() => { let l = tryParseNumber(c.bs, k); k = l.p1; return l.ret; })())) {
                                h.add(k);
                            }
                        }
                    }
                    d.af = h.toArray();
                }
            }
            else {
                d.af = c.bs;
            }
            d.ao();
            this.af = false;
            this.dx(d);
        }
        ce(a, b) {
            let c = a;
            let d = c.ao;
            this.af = true;
            d.ap();
            this.af = false;
            this.dx(d);
        }
        dx(a) {
            if (this.bt != null && this.e != null) {
                if (this.ad) {
                    this.ad = false;
                    this.e.addTargetPropertyUpdatingListener(runOn(this, this.al));
                }
                let b = this.bu == null;
                this.bu = this.b5();
                if (b) {
                    this.l.q(this.bt, (c) => this.e.loadJsonOverlay(this.bu, (d) => c, (d) => this.bt));
                }
                else {
                    this.l.q(this.bt, (c) => this.e.loadJsonDelta(this.bu, (d) => c, false));
                }
            }
        }
        al(a, b, c) {
            let d = this.actualProperties;
            if (typeCast(HorizontalPropertyEditorPanelDataSource.$, d) !== null) {
                d = d.ae;
            }
            for (let e = 0; e < d.count; e++) {
                let f = d._inner[e].an;
                if (this.ak(f, a)) {
                    d._inner[e].ar(a, b, c);
                }
            }
            if (this.ah) {
                return true;
            }
            return false;
        }
        ak(a, b) {
            if (a == null && b == null) {
                return true;
            }
            if (a == null) {
                return false;
            }
            if (b == null) {
                return false;
            }
            let c = stringSplit(a, ['.', '['], 0);
            let d = stringSplit(b, ['.', '['], 0);
            if (c.length != d.length) {
                return false;
            }
            for (let e = 0; e < c.length; e++) {
                let f = c[e];
                let g = d[e];
                if (stringContains(f, "]")) {
                    if (!stringContains(g, "]")) {
                        return false;
                    }
                    g = stringReplace(g, "]", "");
                    let h = this.ao(f);
                    if (!h.contains(g)) {
                        return false;
                    }
                }
                else {
                    if (!Base.equalsStatic(f, g)) {
                        return false;
                    }
                }
            }
            return true;
        }
        ao(a) {
            let b = new List$1(String_$type, 0);
            if (stringContains(a, "]")) {
                a = stringReplace(a, "]", "");
                let c = a.split(',');
                for (let d = 0; d < c.length; d++) {
                    let e = c[d];
                    if (stringContains(e, "as")) {
                        let f = e.indexOf("as");
                        let g = e.substr(0, f).trim();
                        b.add(g);
                    }
                }
                return b;
            }
            b.add(a);
            return b;
        }
        b5() {
            if (this.actualProperties == null) {
                return null;
            }
            let a = this.actualProperties;
            if (typeCast(HorizontalPropertyEditorPanelDataSource.$, a) !== null) {
                a = a.ae;
            }
            let b = new PropertyEditorTreeTransformer(this.h, this.b3);
            this.c3(a, "", b, this.b3);
            return b.g();
        }
        c3(a, b, c, d) {
            for (let e = 0; e < a.count; e++) {
                let f = a._inner[e];
                if (f.p == 20) {
                    continue;
                }
                if (f.i != null && f.i.count > 0) {
                    for (let g = 0; g < f.i.count; g++) {
                        let h = f.i._inner[g];
                        let i = b + f.an + "[" + g + "]";
                        this.c3(h.a, i, c, h.b);
                    }
                }
                else if (f.g != null) {
                    let j = b + f.an;
                    this.c3(f.g.a, j, c, f.g.b);
                }
                else {
                    if (f.p == 15 && f.af == null) {
                        continue;
                    }
                    c.h(b + f.an, f.af, d);
                }
            }
        }
        da(a, b) {
        }
        c7(a, b) {
        }
        c6(a, b) {
            this.c5(a, b);
        }
        c2(a, b) {
        }
        c1(a, b) {
        }
        cz(a, b) {
        }
        c0(a, b) {
            this.c8(a, b);
        }
        c4(a, b) {
            this.c8(a, b);
        }
        cy(a, b) {
        }
        cv(a, b) {
        }
        cw(a, b) {
            this.c8(a, b);
        }
        cu(a, b) {
            this.co(b, (c, d) => {
                c.h = 1;
                if (!c.bk) {
                    c.bk = true;
                }
                let e = this.m(a, b.b, b.c);
                let f = e.af;
                if (f == null) {
                    f = false;
                }
                if (typeof f === 'string') {
                    let g;
                    if (((() => { let h = tryParseBool(f, g); g = h.p1; return h.ret; })())) {
                        f = g;
                        let h = this.af;
                        this.af = true;
                        e.af = f;
                        this.af = h;
                    }
                }
                if (typeof f === 'number') {
                    if (typeGetValue(f) > 0) {
                        f = true;
                        let i = this.af;
                        this.af = true;
                        e.af = f;
                        this.af = i;
                    }
                }
                if (typeof f === 'number') {
                    if (f > 0) {
                        f = true;
                        let j = this.af;
                        this.af = true;
                        e.af = f;
                        this.af = j;
                    }
                }
                let k = f;
                c.bl = k;
                c.ao = e;
                if (d) {
                    c.bj = runOn(this, this.cg);
                }
            });
        }
        m(a, b, c) {
            if (this.ag) {
                let d = this.actualProperties.ae;
                let e = d;
                let f = truncate((this.ap.count / 2));
                let g = b * f;
                let h = this.bo(a);
                h = truncate(Math.floor(h / 2)) + g;
                if (h > e.count - 1) {
                    return null;
                }
                return e.item(h);
            }
            else {
                return c;
            }
        }
        bo(a) {
            return this.am.item(a);
        }
        cg(a, b) {
            let c = a;
            let d = c.ao;
            this.af = true;
            d.af = c.bl;
            d.ao();
            this.af = false;
            this.dx(d);
        }
        ct(a, b) {
        }
        ds(a, b, c) {
            if (this.v != null) {
                this.c.notifySetItem(a, b, c);
            }
        }
        dp() {
            if (this.v != null) {
                this.c.notifyClearItems();
            }
        }
        dq(a, b) {
            if (this.v != null) {
                this.c.notifyInsertItem(a, b);
            }
            ;
        }
        dr(a, b) {
            if (this.v != null) {
                this.c.notifyRemoveItem(a, b);
            }
            ;
        }
        get h() {
            return this.f;
        }
        set h(a) {
            let b = this.f;
            this.f = a;
            this.dw("ActualContext", b, this.f);
        }
        get i() {
            return this.g;
        }
        set i(a) {
            let b = this.g;
            this.g = a;
            this.dw("DescriptionContext", b, this.g);
        }
        get e() {
            return this.d;
        }
        set e(a) {
            let b = this.d;
            this.d = a;
            this.dw("ComponentRenderer", b, this.d);
        }
        get bt() {
            return this.br;
        }
        set bt(a) {
            let b = this.br;
            this.br = a;
            this.dw("Target", b, this.br);
        }
        get b3() {
            return this.bv;
        }
        set b3(a) {
            let b = this.bv;
            this.bv = a;
            this.dw("DescriptionType", b, this.bv);
        }
        get ag() {
            return this.aa;
        }
        set ag(a) {
            let b = this.aa;
            this.aa = a;
            this.dw("IsHorizontal", b, this.aa);
        }
        get ai() {
            return this.ac;
        }
        set ai(a) {
            let b = this.ac;
            this.ac = a;
            this.dw("IsWrappingEnabled", b, this.ac);
        }
        get ah() {
            return this.ab;
        }
        set ah(a) {
            let b = this.ab;
            this.ab = a;
            this.dw("IsIndirectModeEnabled", b, this.ab);
        }
        get d8() {
            return this.d6;
        }
        set d8(a) {
            let b = this.d6;
            this.d6 = a;
            if (b != this.d6) {
                this.dw("BackgroundColor", b, a);
            }
        }
        get eb() {
            return this.d7;
        }
        set eb(a) {
            let b = this.d7;
            this.d7 = a;
            if (b != this.d7) {
                this.dw("TextColor", b, a);
            }
        }
        cf() {
            let a = this.c;
            if (null != a) {
                if (null == a.actualSchema) {
                    this.bm = -1;
                    return;
                }
                let b = a.actualCount;
                this.bm = b;
            }
            else {
                this.bm = -1;
            }
        }
    }
    PropertyEditorPanel.$t = /*@__PURE__*/ markType(PropertyEditorPanel, 'PropertyEditorPanel', Base.$, [INotifyPropertyChanged_$type]);
    PropertyEditorPanel.d9 = /*@__PURE__*/ BrushUtil.h(255, 248, 248, 248);
    PropertyEditorPanel.ea = /*@__PURE__*/ BrushUtil.h(255, 24, 29, 31);
    return PropertyEditorPanel;
})();
