/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, markType } from "igniteui-react-core";
import { IVisualData_$type } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { ToolActionVisualData } from "./ToolActionVisualData";
import { StringBuilder } from "igniteui-react-core";
/**
 * @hidden
 */
export let ToolPanelVisualData = /*@__PURE__*/ (() => {
    class ToolPanelVisualData extends Base {
        constructor() {
            super();
            this.b = null;
            this.c = null;
            this.a = null;
            this.b = new List$1(ToolActionVisualData.$, 0);
            this.c = new List$1(ToolPanelDropdownMenuVisualData.$, 0);
        }
        serialize() {
            let a = new StringBuilder(0);
            a.u("{");
            a.u("actions: [");
            if (this.b.count > 0) {
                for (let b = 0; b < this.b.count; b++) {
                    let c = this.b._inner[b].serialize();
                    a = b < this.b.count - 1 ? a.u(c + ", ") : a.l(c);
                }
            }
            a.u("], ");
            a.u("dropdowns: [");
            if (this.c.count > 0) {
                for (let d = 0; d < this.c.count; d++) {
                    let e = this.c._inner[d].serialize();
                    a = d < this.c.count - 1 ? a.l(e + ", ") : a.l(e);
                }
            }
            a.u("], ");
            a.u("panel: " + this.a.serialize());
            a.u("]");
            a.u("}");
            return a.toString();
        }
    }
    ToolPanelVisualData.$t = /*@__PURE__*/ markType(ToolPanelVisualData, 'ToolPanelVisualData', Base.$, [IVisualData_$type]);
    return ToolPanelVisualData;
})();
/**
 * @hidden
 */
export let ToolPanelDropdownMenuVisualData = /*@__PURE__*/ (() => {
    class ToolPanelDropdownMenuVisualData extends Base {
        constructor() {
            super(...arguments);
            this.a = null;
        }
        serialize() {
            let a = new StringBuilder(0);
            a.u("{");
            if (this.a != null) {
                a.u("toolPanel: " + this.a.serialize() + ", ");
            }
            a.u("}");
            return a.toString();
        }
    }
    ToolPanelDropdownMenuVisualData.$t = /*@__PURE__*/ markType(ToolPanelDropdownMenuVisualData, 'ToolPanelDropdownMenuVisualData', Base.$, [IVisualData_$type]);
    return ToolPanelDropdownMenuVisualData;
})();
