import { IgrListPanelItemModel } from "./igr-list-panel-item-model";
import { ListPanelTemplateItemUpdatingEventArgs as ListPanelTemplateItemUpdatingEventArgs_internal } from "./ListPanelTemplateItemUpdatingEventArgs";
export class IgrListPanelTemplateItemUpdatingEventArgs {
    createImplementation() {
        return new ListPanelTemplateItemUpdatingEventArgs_internal();
    }
    get nativeElement() {
        return this._implementation.nativeElement;
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    get model() {
        const r = this.i.a;
        if (r == null) {
            return null;
        }
        if (!r.externalObject) {
            let e = new IgrListPanelItemModel();
            if (r.$type) {
                e._implementation = r;
            }
            else {
                if (e.i.setNativeElement) {
                    e.i.setNativeElement(r);
                }
            }
            r.externalObject = e;
        }
        return r.externalObject;
    }
    set model(v) {
        v == null ? this.i.a = null : this.i.a = v.i;
    }
    get content() {
        return this.i.c;
    }
    set content(v) {
        this.i.c = v;
    }
}
