import { IgCollection } from "igniteui-react-core";
import { markType } from "igniteui-react-core";
import { SyncableObservableCollection$2 } from "igniteui-react-core";
import { ToolActionEventDetail as ToolActionEventDetail_internal } from './ToolActionEventDetail';
import { IgrToolActionEventDetail as IgrToolActionEventDetail } from './igr-tool-action-event-detail';
export class IgrToolActionEventDetailCollection extends IgCollection {
    constructor(list) {
        super();
        if (!IgrToolActionEventDetail.$type) {
            IgrToolActionEventDetail.$type = markType(IgrToolActionEventDetail, "IgrToolActionEventDetail");
        }
        if (list) {
            for (let i = 0; i < list.length; i++) {
                this.add(list[i]);
            }
        }
    }
    _createInnerColl() {
        if (!IgrToolActionEventDetail.$type) {
            IgrToolActionEventDetail.$type = markType(IgrToolActionEventDetail, "IgrToolActionEventDetail");
        }
        let coll = new SyncableObservableCollection$2(IgrToolActionEventDetail.$type, ToolActionEventDetail_internal.$type, 0);
        coll.compare = (ext, int) => {
            let comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = (ext) => {
            return ext._implementation;
        };
        coll.createFrom = (int) => {
            let ext = int.externalObject;
            if (!ext) {
                ext = new IgrToolActionEventDetail();
                if (ext) {
                    if (!int.$type && ext._implementation.setNativeElement) {
                        ext._implementation.setNativeElement(int);
                    }
                    else {
                        ext._implementation = int;
                    }
                }
            }
            return ext;
        };
        return coll;
    }
}
