import { IgrToolAction } from "./igr-tool-action";
import { ToolActionGroupHeader } from "./ToolActionGroupHeader";
import { brushToString, stringToBrush } from "igniteui-react-core";
export class IgrToolActionGroupHeader extends IgrToolAction {
    createImplementation() {
        return new ToolActionGroupHeader();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor(props) {
        super(props);
    }
    /**
     * Gets the actual back icon color.
    */
    get actualBackIconColor() {
        return brushToString(this.i.hj);
    }
    set actualBackIconColor(v) {
        this.i.hj = stringToBrush(v);
    }
    /**
     * Gets or sets the icon color for the back button.
    */
    get backIconColor() {
        return brushToString(this.i.hk);
    }
    set backIconColor(v) {
        this.i.hk = stringToBrush(v);
    }
}
