import { IgrToolAction } from "./igr-tool-action";
import { ToolActionIconButton } from "./ToolActionIconButton";
export class IgrToolActionIconButton extends IgrToolAction {
    createImplementation() {
        return new ToolActionIconButton();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor(props) {
        super(props);
    }
    /**
     * Gets or sets how long it takes before the tooltip is displayed (in milliseconds).
    */
    get tooltipDelay() {
        return this.i.ib;
    }
    set tooltipDelay(v) {
        this.i.ib = +v;
    }
    /**
     * Gets the actual delay before the tooltip is displayed (in milliseconds).
    */
    get actualTooltipDelay() {
        return this.i.ia;
    }
    set actualTooltipDelay(v) {
        this.i.ia = +v;
    }
    get contentPaddingLeft() {
        return this.i.h3;
    }
    set contentPaddingLeft(v) {
        this.i.h3 = +v;
    }
    get actualContentPaddingLeft() {
        return this.i.hz;
    }
    set actualContentPaddingLeft(v) {
        this.i.hz = +v;
    }
    get contentPaddingTop() {
        return this.i.h5;
    }
    set contentPaddingTop(v) {
        this.i.h5 = +v;
    }
    get actualContentPaddingTop() {
        return this.i.h1;
    }
    set actualContentPaddingTop(v) {
        this.i.h1 = +v;
    }
    get contentPaddingRight() {
        return this.i.h4;
    }
    set contentPaddingRight(v) {
        this.i.h4 = +v;
    }
    get actualContentPaddingRight() {
        return this.i.h0;
    }
    set actualContentPaddingRight(v) {
        this.i.h0 = +v;
    }
    get contentPaddingBottom() {
        return this.i.h2;
    }
    set contentPaddingBottom(v) {
        this.i.h2 = +v;
    }
    get actualContentPaddingBottom() {
        return this.i.hy;
    }
    set actualContentPaddingBottom(v) {
        this.i.hy = +v;
    }
    cleanUp() {
        this.i.e3();
    }
    openSubMenu() {
        this.i.fy();
    }
    closeSubmenu() {
        this.i.e5();
    }
    exportVisualData() {
        let iv = this.i.cn();
        return (iv);
    }
}
