/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { ObservableCollection$1 } from "igniteui-react-core";
import { LayoutPrimaryKeyValue } from "./LayoutPrimaryKeyValue";
import { PropertyChangedEventArgs, delegateCombine, Number_$type, fromEnum, markType } from "igniteui-react-core";
import { NotifyCollectionChangedEventArgs } from "igniteui-react-core";
import { Dictionary$2 } from "igniteui-react-core";
/**
 * @hidden
 */
var LayoutSelectedKeysCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(LayoutSelectedKeysCollection, _super);
    function LayoutSelectedKeysCollection() {
        var _this = _super.call(this, LayoutPrimaryKeyValue.$, 0) || this;
        _this.ah = false;
        _this.af = true;
        _this.ai = new Dictionary$2(LayoutPrimaryKeyValue.$, Number_$type, 0);
        _this.aj = new Dictionary$2(Number_$type, LayoutPrimaryKeyValue.$, 0);
        return _this;
    }
    Object.defineProperty(LayoutSelectedKeysCollection.prototype, "ae", {
        get: function () {
            return this;
        },
        enumerable: false,
        configurable: true
    });
    LayoutSelectedKeysCollection.prototype.al = function (a) {
        this.collectionChanged = delegateCombine(this.collectionChanged, a);
    };
    Object.defineProperty(LayoutSelectedKeysCollection.prototype, "ag", {
        get: function () {
            return this.af;
        },
        set: function (a) {
            this.af = a;
        },
        enumerable: false,
        configurable: true
    });
    LayoutSelectedKeysCollection.prototype.n = function (a) {
        _super.prototype.n.call(this, a);
        if (this.ag) {
            this.ai.addItem(a, this.count - 1);
            this.aj.addItem(this.count - 1, a);
        }
    };
    LayoutSelectedKeysCollection.prototype.o = function (a) {
        var e_1, _a;
        var b = this.count;
        _super.prototype.o.call(this, a);
        if (this.ag) {
            try {
                for (var _b = __values(fromEnum(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var c = _c.value;
                    this.ai.addItem(c, b);
                    this.aj.addItem(b, c);
                    b++;
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
        }
    };
    LayoutSelectedKeysCollection.prototype.p = function () {
        _super.prototype.p.call(this);
        if (this.ag) {
            this.ai.clear();
            this.aj.clear();
        }
    };
    LayoutSelectedKeysCollection.prototype.u = function (a) {
        if (this.ag) {
            if (this.aj.containsKey(a)) {
                var b = this.aj.item(a);
                this.ai.removeItem(b);
                this.aj.removeItem(a);
                for (var c = a + 1; c < this.count; c++) {
                    if (this.aj.containsKey(c)) {
                        var d = this.aj.item(c);
                        this.aj.removeItem(c);
                        this.aj.addItem(c - 1, d);
                        this.ai.item(d, c - 1);
                    }
                }
            }
        }
        var e = this._inner[a];
        if (a == 0) {
            this._inner.shift();
        }
        else {
            this._inner.splice(a, 1);
        }
        this.ad(new PropertyChangedEventArgs("Count"));
        this.ad(new PropertyChangedEventArgs("Item[]"));
        if (!this.ah) {
            this.ac(new NotifyCollectionChangedEventArgs(1, 1, e, a));
        }
    };
    LayoutSelectedKeysCollection.prototype.v = function (index_, numToRemove_) {
        _super.prototype.v.call(this, index_, numToRemove_);
        if (this.ag) {
            for (var a = index_; a < index_ + numToRemove_; a++) {
                if (this.aj.containsKey(a)) {
                    var b = this.aj.item(a);
                    this.ai.removeItem(b);
                    this.aj.removeItem(a);
                }
            }
        }
    };
    LayoutSelectedKeysCollection.prototype.x = function (a, b) {
        _super.prototype.x.call(this, a, b);
        if (this.ag) {
            if (this.aj.containsKey(a)) {
                var c = this.aj.item(a);
                this.aj.item(a, b);
                this.ai.removeItem(c);
                this.ai.addItem(b, a);
            }
        }
    };
    LayoutSelectedKeysCollection.prototype.r = function (a, b) {
        _super.prototype.r.call(this, a, b);
        if (this.ag) {
            for (var c = a; c < this.count; c++) {
                var d = this._inner[c];
                if (this.ai.containsKey(d)) {
                    this.ai.item(d, c);
                    this.aj.removeItem(c);
                    this.aj.addItem(c, d);
                }
                else {
                    this.ai.addItem(d, c);
                    this.aj.addItem(c, d);
                }
            }
        }
    };
    LayoutSelectedKeysCollection.prototype.ak = function (a) {
        if (this.ag) {
            if (this.ai.containsKey(a)) {
                return this.ai.item(a);
            }
            return -1;
        }
        return this.indexOf(a);
    };
    LayoutSelectedKeysCollection.$t = markType(LayoutSelectedKeysCollection, 'LayoutSelectedKeysCollection', ObservableCollection$1.$.specialize(LayoutPrimaryKeyValue.$));
    return LayoutSelectedKeysCollection;
}(ObservableCollection$1));
export { LayoutSelectedKeysCollection };
