import { __extends } from "tslib";
import { IgCollection } from "igniteui-react-core";
import { markType } from "igniteui-react-core";
import { SyncableObservableCollection$2 } from "igniteui-react-core";
import { LayoutPrimaryKeyValue as LayoutPrimaryKeyValue_internal } from './LayoutPrimaryKeyValue';
import { IgrLayoutPrimaryKeyValue as IgrLayoutPrimaryKeyValue } from './igr-layout-primary-key-value';
var IgrLayoutSelectedKeysCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrLayoutSelectedKeysCollection, _super);
    function IgrLayoutSelectedKeysCollection(list) {
        var _this = _super.call(this) || this;
        if (!IgrLayoutPrimaryKeyValue.$type) {
            IgrLayoutPrimaryKeyValue.$type = markType(IgrLayoutPrimaryKeyValue, "IgrLayoutPrimaryKeyValue");
        }
        if (list) {
            for (var i = 0; i < list.length; i++) {
                _this.add(list[i]);
            }
        }
        return _this;
    }
    IgrLayoutSelectedKeysCollection.prototype._createInnerColl = function () {
        if (!IgrLayoutPrimaryKeyValue.$type) {
            IgrLayoutPrimaryKeyValue.$type = markType(IgrLayoutPrimaryKeyValue, "IgrLayoutPrimaryKeyValue");
        }
        var coll = new SyncableObservableCollection$2(IgrLayoutPrimaryKeyValue.$type, LayoutPrimaryKeyValue_internal.$type, 0);
        coll.compare = function (ext, int) {
            var comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = function (ext) {
            return ext._implementation;
        };
        coll.createFrom = function (int) {
            var ext = int.externalObject;
            if (!ext) {
                ext = new IgrLayoutPrimaryKeyValue();
                if (ext) {
                    if (!int.$type && ext._implementation.setNativeElement) {
                        ext._implementation.setNativeElement(int);
                    }
                    else {
                        ext._implementation = int;
                    }
                }
            }
            return ext;
        };
        return coll;
    };
    return IgrLayoutSelectedKeysCollection;
}(IgCollection));
export { IgrLayoutSelectedKeysCollection };
