import { OnExpandedEventArgs as OnExpandedEventArgs_internal } from "./OnExpandedEventArgs";
var IgrOnExpandedEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrOnExpandedEventArgs() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrOnExpandedEventArgs.prototype.createImplementation = function () {
        return new OnExpandedEventArgs_internal();
    };
    Object.defineProperty(IgrOnExpandedEventArgs.prototype, "nativeElement", {
        get: function () {
            return this._implementation.nativeElement;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrOnExpandedEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrOnExpandedEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrOnExpandedEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    return IgrOnExpandedEventArgs;
}());
export { IgrOnExpandedEventArgs };
