import { __extends } from "tslib";
import { IgCollection } from "igniteui-react-core";
import { markType } from "igniteui-react-core";
import { SyncableObservableCollection$2 } from "igniteui-react-core";
import { ToolAction as ToolAction_internal } from './ToolAction';
import { IgrToolAction as IgrToolAction } from './igr-tool-action';
var IgrToolActionCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrToolActionCollection, _super);
    function IgrToolActionCollection(list) {
        var _this = _super.call(this) || this;
        if (!IgrToolAction.$type) {
            IgrToolAction.$type = markType(IgrToolAction, "IgrToolAction");
        }
        if (list) {
            for (var i = 0; i < list.length; i++) {
                _this.add(list[i]);
            }
        }
        return _this;
    }
    IgrToolActionCollection.prototype._createInnerColl = function () {
        if (!IgrToolAction.$type) {
            IgrToolAction.$type = markType(IgrToolAction, "IgrToolAction");
        }
        var coll = new SyncableObservableCollection$2(IgrToolAction.$type, ToolAction_internal.$type, 0);
        coll.compare = function (ext, int) {
            var comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = function (ext) {
            return ext._implementation;
        };
        coll.createFrom = function (int) {
            var ext = int.externalObject;
            if (!ext) {
                ext = IgrToolAction._createFromInternal(int);
                if (ext) {
                    if (!int.$type && ext._implementation.setNativeElement) {
                        ext._implementation.setNativeElement(int);
                    }
                    else {
                        ext._implementation = int;
                    }
                }
            }
            return ext;
        };
        return coll;
    };
    return IgrToolActionCollection;
}(IgCollection));
export { IgrToolActionCollection };
