import { ToolCommandEventArgs as ToolCommandEventArgs_internal } from "./ToolCommandEventArgs";
var IgrToolCommandEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrToolCommandEventArgs() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrToolCommandEventArgs.prototype.createImplementation = function () {
        return new ToolCommandEventArgs_internal();
    };
    Object.defineProperty(IgrToolCommandEventArgs.prototype, "nativeElement", {
        get: function () {
            return this._implementation.nativeElement;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolCommandEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrToolCommandEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrToolCommandEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrToolCommandEventArgs.prototype, "command", {
        get: function () {
            return this.i.a;
        },
        set: function (v) {
            this.i.a = v;
        },
        enumerable: false,
        configurable: true
    });
    return IgrToolCommandEventArgs;
}());
export { IgrToolCommandEventArgs };
