import { ToolPanelContextChangedEventArgs as ToolPanelContextChangedEventArgs_internal } from "./ToolPanelContextChangedEventArgs";
var IgrToolPanelContextChangedEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrToolPanelContextChangedEventArgs() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrToolPanelContextChangedEventArgs.prototype.createImplementation = function () {
        return new ToolPanelContextChangedEventArgs_internal();
    };
    Object.defineProperty(IgrToolPanelContextChangedEventArgs.prototype, "nativeElement", {
        get: function () {
            return this._implementation.nativeElement;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolPanelContextChangedEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrToolPanelContextChangedEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrToolPanelContextChangedEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrToolPanelContextChangedEventArgs.prototype, "id", {
        get: function () {
            return this.i.c;
        },
        set: function (v) {
            this.i.c = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolPanelContextChangedEventArgs.prototype, "propertyName", {
        get: function () {
            return this.i.d;
        },
        set: function (v) {
            this.i.d = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolPanelContextChangedEventArgs.prototype, "oldValue", {
        get: function () {
            return this.i.b;
        },
        set: function (v) {
            this.i.b = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolPanelContextChangedEventArgs.prototype, "newValue", {
        get: function () {
            return this.i.a;
        },
        set: function (v) {
            this.i.a = v;
        },
        enumerable: false,
        configurable: true
    });
    return IgrToolPanelContextChangedEventArgs;
}());
export { IgrToolPanelContextChangedEventArgs };
