import { PropertyEditorPanel } from "./PropertyEditorPanel";
import { Type } from "igniteui-react-core";
import { Size } from "igniteui-react-core";
import { FontInfo } from "igniteui-react-core";
/**
 * @hidden
 */
export interface IPropertyEditorPanelView {
    onInit(): void;
    onContainerProvided(a: any): void;
    setupFilter(): void;
    setGridHeight(): void;
    onTemplateProvided(a: any, b: any): void;
    notifySizeChanged(a: Size): void;
    measureString(a: string): number;
    getDefaultCellTextStyle(): FontInfo;
    getAvailableWidth(): number;
    getContainer(a: any, b: (arg1: any) => void): void;
    getUIContext(): any;
    needsMeasure(): void;
    model: PropertyEditorPanel;
}
/**
 * @hidden
 */
export declare let IPropertyEditorPanelView_$type: Type;
