import { Base, Type, INotifyPropertyChanged, PropertyChangedEventArgs } from "igniteui-react-core";
import { DomRenderer, DomWrapper } from "igniteui-react-core";
import { RenderingContext } from "igniteui-react-core";
import { FontInfo } from "igniteui-react-core";
import { Size } from "igniteui-react-core";
import { NativeUIGrid } from "igniteui-react-core";
import { PropertyEditorPropertyDescriptionCollection } from "./PropertyEditorPropertyDescriptionCollection";
import { IDataSource } from "igniteui-react-core";
import { IExecutionContext } from "igniteui-react-core";
import { ObservableCollection$1 } from "igniteui-react-core";
import { PropertyEditorPanelColumnDefinition } from "./PropertyEditorPanelColumnDefinition";
import { TypeDescriptionContext } from "igniteui-react-core";
import { ComponentRenderer } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
/**
 * @hidden
 */
export declare class PropertyEditorPanelView extends Base {
    static $t: Type;
    private n;
    private m;
    constructor();
    p(): any;
    a: PropertyEditorPanel;
    v(): void;
    i: DomRenderer;
    l: DomWrapper;
    e: RenderingContext;
    k: DomWrapper;
    t(a: DomRenderer): void;
    y(): void;
    x(): void;
    s(): void;
    z(): void;
    private b;
    private aa;
    private c;
    private _gridExternal;
    d(): FontInfo;
    u(): void;
    w(): void;
    r(): void;
    g(): number;
    h(a: string): number;
    f: boolean;
    private j;
    q(a: any, b: (arg1: any) => void): void;
}
/**
 * @hidden
 */
export declare class PropertyEditorPanel extends Base implements INotifyPropertyChanged {
    static $t: Type;
    l: PropertyEditorPanelView;
    v: NativeUIGrid;
    private r;
    private y;
    private z;
    private w;
    private get x();
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    constructor();
    private dz;
    private dv;
    private dl;
    private af;
    notifySizeChanged(): void;
    dj(a: NativeUIGrid, b: any): void;
    destroy(): void;
    provideContainer(a: DomRenderer): void;
    du(a: string): void;
    private n;
    get actualProperties(): PropertyEditorPropertyDescriptionCollection;
    set actualProperties(a: PropertyEditorPropertyDescriptionCollection);
    private o;
    get properties(): PropertyEditorPropertyDescriptionCollection;
    set properties(a: PropertyEditorPropertyDescriptionCollection);
    private bl;
    get bq(): number;
    set bq(a: number);
    private aq;
    get ar(): number;
    set ar(a: number);
    private s;
    get t(): FontInfo;
    set t(a: FontInfo);
    u(): FontInfo;
    private bs;
    c: IDataSource;
    protected dw(a: string, b: any, c: any): void;
    protected d0(a: string, b: any, c: any): void;
    private aj;
    private an;
    j: IExecutionContext;
    private ae;
    private d2;
    private ck;
    private dy;
    ap: ObservableCollection$1<PropertyEditorPanelColumnDefinition>;
    d4(): void;
    private bk;
    private ch;
    ec(): Size;
    private bn;
    private d3;
    private cm;
    private dn;
    private a6;
    private bj;
    private a9;
    private aw;
    private bg;
    private bi;
    private bh;
    private bf;
    private be;
    private bd;
    private bc;
    private bb;
    private a8;
    private a7;
    private a5;
    private a2;
    private a3;
    private a1;
    private az;
    private a0;
    private ay;
    private au;
    private a4;
    private av;
    private at;
    private ax;
    private as;
    private ba;
    private b6;
    private dm;
    private cl;
    private di;
    private dh;
    private dg;
    private de;
    private dd;
    private dc;
    private db;
    private c9;
    private c8;
    private cr;
    private cq;
    private cn;
    private cs;
    private cp;
    private co;
    private cx;
    private df;
    private d5;
    private c5;
    private b;
    private a;
    private ci;
    private dk;
    private ce;
    private bu;
    private ad;
    private dx;
    private al;
    private ak;
    private ao;
    private b5;
    private c3;
    private da;
    private c7;
    private c6;
    private c2;
    private c1;
    private cz;
    private c0;
    private c4;
    private cy;
    private cv;
    private cw;
    private cu;
    private m;
    private am;
    private bo;
    private cg;
    private ct;
    ds(a: number, b: any, c: any): void;
    dp(): void;
    dq(a: number, b: any): void;
    dr(a: number, b: any): void;
    private f;
    get h(): TypeDescriptionContext;
    set h(a: TypeDescriptionContext);
    private g;
    get i(): TypeDescriptionContext;
    set i(a: TypeDescriptionContext);
    private d;
    get e(): ComponentRenderer;
    set e(a: ComponentRenderer);
    private br;
    get bt(): any;
    set bt(a: any);
    private bv;
    get b3(): string;
    set b3(a: string);
    private aa;
    get ag(): boolean;
    set ag(a: boolean);
    private ac;
    get ai(): boolean;
    set ai(a: boolean);
    private ab;
    get ah(): boolean;
    set ah(a: boolean);
    static d9: Brush;
    private d6;
    get d8(): Brush;
    set d8(a: Brush);
    static ea: Brush;
    d7: Brush;
    get eb(): Brush;
    set eb(a: Brush);
    private bp;
    private bm;
    private k;
    private cf;
}
