import { PropertyEditorDataSource as PropertyEditorDataSource_internal } from "./PropertyEditorDataSource";
import { ContentChildrenManager } from "igniteui-react-core";
import { TypeDescriptionContext } from "igniteui-react-core";
export declare class IgrPropertyEditorDataSource {
    protected createImplementation(): PropertyEditorDataSource_internal;
    protected _implementation: any;
    protected mounted: boolean;
    get nativeElement(): HTMLElement;
    /**
     * @hidden
     */
    get i(): PropertyEditorDataSource_internal;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    get descriptionType(): string;
    set descriptionType(v: string);
    get context(): TypeDescriptionContext;
    set context(v: TypeDescriptionContext);
    findByName(name: string): any;
}
