import { IgrLayoutSelectedKeysCollection } from "./igr-layout-selected-keys-collection";
import { IgrToolAction, IIgrToolActionProps } from "./igr-tool-action";
import { ToolActionCheckboxList } from "./ToolActionCheckboxList";
export declare class IgrToolActionCheckboxList extends IgrToolAction<IIgrToolActionCheckboxListProps> {
    protected createImplementation(): ToolActionCheckboxList;
    /**
                                 * @hidden
                                 */
    get i(): ToolActionCheckboxList;
    constructor(props: IIgrToolActionCheckboxListProps);
    /**
     * Gets or sets if the tool action is checked.
    */
    get dataSource(): any;
    set dataSource(v: any);
    /**
     * Gets or sets if the tool action is checked.
    */
    get selectedMemberPath(): string;
    set selectedMemberPath(v: string);
    /**
     * Gets or sets if the tool action is checked.
    */
    get dataMemberPath(): string;
    set dataMemberPath(v: string);
    /**
     * Gets or sets if the tool action is checked.
    */
    get primaryKey(): string[];
    set primaryKey(v: string[]);
    private _selectedKeys;
    /**
    
    */
    get selectedKeys(): IgrLayoutSelectedKeysCollection;
    set selectedKeys(v: IgrLayoutSelectedKeysCollection);
    findByName(name: string): any;
}
export interface IIgrToolActionCheckboxListProps extends IIgrToolActionProps {
    /**
     * Gets or sets if the tool action is checked.
    */
    dataSource?: any;
    /**
     * Gets or sets if the tool action is checked.
    */
    selectedMemberPath?: string;
    /**
     * Gets or sets if the tool action is checked.
    */
    dataMemberPath?: string;
    /**
     * Gets or sets if the tool action is checked.
    */
    primaryKey?: string[];
    /**
    
    */
    selectedKeys?: IgrLayoutSelectedKeysCollection | string;
}
