import { ToolActionType } from "igniteui-react-core";
import { ToolActionEventDetail as ToolActionEventDetail_internal } from "./ToolActionEventDetail";
import { ContentChildrenManager } from "igniteui-react-core";
export declare class IgrToolActionEventDetail {
    protected createImplementation(): ToolActionEventDetail_internal;
    protected _implementation: any;
    protected mounted: boolean;
    get nativeElement(): HTMLElement;
    /**
     * @hidden
     */
    get i(): ToolActionEventDetail_internal;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    get actionId(): string;
    set actionId(v: string);
    get actionType(): ToolActionType;
    set actionType(v: ToolActionType);
    get isModified(): boolean;
    set isModified(v: boolean);
    get boolValue(): boolean;
    set boolValue(v: boolean);
    get numberValue(): number;
    set numberValue(v: number);
    get dateTimeValue(): Date;
    set dateTimeValue(v: Date);
    get untypedValue(): any;
    set untypedValue(v: any);
    findByName(name: string): any;
}
