import { IgrToolAction, IIgrToolActionProps } from "./igr-tool-action";
import { ToolActionGroupHeader } from "./ToolActionGroupHeader";
export declare class IgrToolActionGroupHeader extends IgrToolAction<IIgrToolActionGroupHeaderProps> {
    protected createImplementation(): ToolActionGroupHeader;
    /**
                                 * @hidden
                                 */
    get i(): ToolActionGroupHeader;
    constructor(props: IIgrToolActionGroupHeaderProps);
    /**
     * Gets the actual back icon color.
    */
    get actualBackIconColor(): string;
    set actualBackIconColor(v: string);
    /**
     * Gets or sets the icon color for the back button.
    */
    get backIconColor(): string;
    set backIconColor(v: string);
}
export interface IIgrToolActionGroupHeaderProps extends IIgrToolActionProps {
    /**
     * Gets the actual back icon color.
    */
    actualBackIconColor?: string;
    /**
     * Gets or sets the icon color for the back button.
    */
    backIconColor?: string;
}
