/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, runOn, markType, INotifyPropertyChanged_$type, PropertyChangedEventArgs } from "igniteui-react-core";
import { ElevationHelper } from "igniteui-react-core";
import { NativeUI } from "igniteui-react-core";
import { AnimationKeyFrameEffect } from "igniteui-react-core";
import { AnimationKeyFrameEffectTiming } from "igniteui-react-core";
import { KeyFrameAnimationFactory } from "igniteui-react-core";
import { BaseDOMEventProxy } from "igniteui-react-core";
import { ExpansionPanelUtilities } from "./ExpansionPanelUtilities";
import { BrushUtil } from "igniteui-react-core";
import { OnCollapsedEventArgs } from "./OnCollapsedEventArgs";
import { OnExpandedEventArgs } from "./OnExpandedEventArgs";
import { AnimationKeyFrameProperty } from "igniteui-react-core";
import { TranslateTransform } from "igniteui-react-core";
import { stringEmpty } from "igniteui-react-core";
/**
 * @hidden
 */
export let ExpansionPanelView = /*@__PURE__*/ (() => {
    class ExpansionPanelView extends Base {
        constructor() {
            super(...arguments);
            this.j = null;
            this.q = null;
            this.g = null;
            this.f = null;
            this.p = null;
            this.l = null;
            this.o = null;
            this.n = null;
            this.m = null;
        }
        get r() {
            return this.q;
        }
        get h() {
            return this.g;
        }
        get k() {
            return this.j;
        }
        ab() {
            this.r.setStyleProperty("display", "flex");
            this.r.setStyleProperty("flexDirection", "column");
            this.r.setStyleProperty("flexWrap", "no-wrap");
            this.r.setStyleProperty("alignItems", "left");
        }
        aj() {
            let a = this.h;
            let b = ElevationHelper.e(a.q, a.bn, a.bm, a.bi);
            this.r.setStyleProperty("box-shadow", b);
        }
        ak() {
            if (null == this.r) {
                return;
            }
            this.aj();
            this.ah();
            this.ai();
            this.ag();
            if (null != this.p) {
                NativeUI.m(this.p, this.h.bl);
            }
            if (null != this.l) {
                NativeUI.q(this.l, this.h.bj);
            }
            if (null != this.o) {
                NativeUI.q(this.o, this.h.bk);
            }
        }
        a(a) {
            return new AnimationKeyFrameEffect(0, this.l, 0, null, a);
        }
        b(a) {
            return new AnimationKeyFrameEffect(0, this.o, 0, null, a);
        }
        c(a) {
            return new AnimationKeyFrameEffect(0, this.p, 0, null, a);
        }
        d(a) {
            return new AnimationKeyFrameEffect(0, this.m, 0, null, a);
        }
        e(a) {
            return new AnimationKeyFrameEffect(0, this.n, 0, null, a);
        }
        u() {
            if (KeyFrameAnimationFactory.h == null) {
                KeyFrameAnimationFactory.h = this.k;
            }
        }
        i() {
            return this.m.outerHeight();
        }
        ac(a) {
            if (a == null) {
                this.j = null;
                return;
            }
            this.j = a;
            let b = a.rootWrapper;
            this.y(b);
        }
        ag() {
            if (null == this.f) {
                return;
            }
            let a = this.h.n;
            if (a) {
                this.f.svgPath = ExpansionPanelView.s;
            }
            else {
                this.f.svgPath = ExpansionPanelView.t;
            }
        }
        ah() {
            if (null != this.l) {
                let a = this.h.ab;
                this.l.setRawText(a);
            }
        }
        ai() {
            if (null != this.o) {
                let a = this.h.ah;
                this.o.setRawText(a);
            }
        }
        y(a) {
            this.q = a;
            this.ab();
        }
        z(a) {
            this.g = a;
        }
        aa() {
        }
        af(a) {
            let b = this.k;
            this.p = a;
            let c = b.createElement("div");
            this.p.append(c);
            this.v(c);
            let d = b.createElement("div");
            d.setStyleProperty("display", "flex");
            d.setStyleProperty("flex-direction", "column");
            d.setStyleProperty("justify-content", "space-evenly");
            d.setStyleProperty("align-items", "flex-start");
            this.p.append(d);
            let e = b.createElement("div");
            d.append(e);
            this.l = b.createElement("label");
            e.append(this.l);
            let f = b.createElement("div");
            d.append(f);
            this.o = b.createElement("label");
            f.append(this.o);
            this.p.setAttribute("tabindex", "0");
            this.p.setStyleProperty("display", "flex");
            this.p.setStyleProperty("flex-direction", "row");
            c.setStyleProperty("display", "flex");
            c.setStyleProperty("justify-content", "center");
            c.setStyleProperty("flex-direction", "column");
            c.setStyleProperty("margin", "0px 10px 0px 10px");
            c.setStyleProperty("flex", "none | 0 | content");
            this.ak();
            this.p.listen("click", runOn(this, this.w));
            this.p.listen("keydown", runOn(this, this.x));
        }
        v(a) {
            if (this.f != null) {
                return;
            }
            this.j.getPortal(a, "XIcon", (b) => {
                let c = b.componentRef;
                this.f = (c.i);
                this.f.fill = ExpansionPanelView.al;
                this.ag();
            }, false);
        }
        ae(a) {
            let b = this.k;
            this.n = a;
            this.n.setAttribute("tabindex", "1");
            this.n.setStyleProperty("overflow", "hidden");
        }
        ad(a) {
            let b = this.k;
            this.m = a;
        }
        w(a) {
            let b = a.originalEvent;
            let c = b.target;
            this.h.a2();
        }
        x(a) {
            let b = BaseDOMEventProxy.c0(a);
            let c = ExpansionPanelUtilities.c(a);
            switch (b) {
                case 9:
                case 3:
                    this.h.a2();
                    a.preventDefault();
                    break;
                case 17:
                    if (c == 1) {
                        this.h.au();
                        a.preventDefault();
                    }
                    break;
                case 15:
                    if (c == 1) {
                        this.h.ar();
                        a.preventDefault();
                    }
                    break;
            }
        }
    }
    ExpansionPanelView.$t = /*@__PURE__*/ markType(ExpansionPanelView, 'ExpansionPanelView');
    ExpansionPanelView.al = /*@__PURE__*/ BrushUtil.h(255, 33, 150, 243);
    ExpansionPanelView.t = "M16.59 8.59L12 13.17 7.41 8.59 6 10l6 6 6-6z";
    ExpansionPanelView.s = "M12 8l-6 6 1.41 1.41L12 10.83l4.59 4.58L18 14z";
    return ExpansionPanelView;
})();
/**
 * @hidden
 */
export let XExpansionPanel = /*@__PURE__*/ (() => {
    class XExpansionPanel extends Base {
        constructor() {
            super();
            this.c = null;
            this.onCollapsed = null;
            this.onExpanded = null;
            this.propertyChanged = null;
            this.g = null;
            this.aa = "Caption";
            this.bb = null;
            this.a4 = XExpansionPanel.bs;
            this.a9 = null;
            this.ba = null;
            this.ag = stringEmpty();
            this.be = null;
            this.a5 = XExpansionPanel.bt;
            this.bc = null;
            this.bd = null;
            this.p = -1;
            this.o = XExpansionPanel.r;
            this.m = true;
            this.bf = null;
            this.a6 = XExpansionPanel.bu;
            this.bg = null;
            this.bh = null;
            this.a8 = XExpansionPanel.bw;
            this.a7 = XExpansionPanel.bv;
            this.a3 = XExpansionPanel.br;
            let a = this.f();
            this.g = a;
            a.z(this);
        }
        aw(a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs(a));
            }
            this.ax(a, b, c);
        }
        get ab() {
            return this.aa;
        }
        set ab(a) {
            if (a == this.aa) {
                return;
            }
            let b = this.aa;
            this.aa = a;
            this.aw("Caption", b, this.aa);
        }
        get bq() {
            return this.bb;
        }
        set bq(a) {
            let b = this.bb;
            this.bb = a;
            if (b != this.bb) {
                this.aw("CaptionTextColor", b, a);
            }
        }
        get bj() {
            return this.a4;
        }
        set bj(a) {
            let b = this.a4;
            this.a4 = a;
            if (b != this.a4) {
                this.aw("ActualCaptionTextColor", b, a);
            }
        }
        get bo() {
            return this.a9;
        }
        set bo(a) {
            let b = this.a9;
            this.a9 = a;
            if (b != this.a9) {
                this.aw("CaptionCollapsedTextColor", b, a);
            }
        }
        get bp() {
            return this.ba;
        }
        set bp(a) {
            let b = this.ba;
            this.ba = a;
            if (b != this.ba) {
                this.aw("CaptionExpandedTextColor", b, a);
            }
        }
        get ah() {
            return this.ag;
        }
        set ah(a) {
            if (a == this.ag) {
                return;
            }
            let b = this.ag;
            this.ag = a;
            this.aw("Description", b, this.ag);
        }
        get bz() {
            return this.be;
        }
        set bz(a) {
            let b = this.be;
            this.be = a;
            if (b != this.be) {
                this.aw("DescriptionTextColor", b, a);
            }
        }
        get bk() {
            return this.a5;
        }
        set bk(a) {
            let b = this.a5;
            this.a5 = a;
            if (b != this.a5) {
                this.aw("ActualDescriptionTextColor", b, a);
            }
        }
        get bx() {
            return this.bc;
        }
        set bx(a) {
            let b = this.bc;
            this.bc = a;
            if (b != this.bc) {
                this.aw("DescriptionCollapsedTextColor", b, a);
            }
        }
        get by() {
            return this.bd;
        }
        set by(a) {
            let b = this.bd;
            this.bd = a;
            if (b != this.bd) {
                this.aw("DescriptionExpandedTextColor", b, a);
            }
        }
        get s() {
            return this.p;
        }
        set s(a) {
            let b = this.p;
            this.p = a;
            if (b != this.p) {
                this.aw("Elevation", b, a);
            }
        }
        get q() {
            return this.o;
        }
        set q(a) {
            let b = this.o;
            this.o = a;
            if (b != this.o) {
                this.aw("ActualElevation", b, a);
            }
        }
        get n() {
            return this.m;
        }
        set n(a) {
            if (a == this.m) {
                return;
            }
            this.at();
            let b = this.m;
            this.m = a;
            let c = this.h(this.m);
            let d = this.i(this.m);
            let e = this.j(this.m);
            let f = this.k(this.m);
            let g = this.l(this.m);
            c.play();
            d.play();
            e.play();
            f.play();
            g.play();
            c.finished.f((h) => c.commitStyles());
            d.finished.f((h) => d.commitStyles());
            e.finished.f((h) => e.commitStyles());
            f.finished.f((h) => f.commitStyles());
            g.finished.f((h) => {
                g.commitStyles();
                this.aw("Expanded", b, this.m);
                if (this.m) {
                    if (this.onExpanded != null) {
                        this.onExpanded(this, new OnExpandedEventArgs());
                    }
                    else if (this.onCollapsed != null) {
                        this.onCollapsed(this, new OnCollapsedEventArgs());
                    }
                }
            });
        }
        get b6() {
            return this.bf;
        }
        set b6(a) {
            let b = this.bf;
            this.bf = a;
            if (b != this.bf) {
                this.aw("HeaderBackgroundColor", b, a);
            }
        }
        get bl() {
            return this.a6;
        }
        set bl(a) {
            let b = this.a6;
            this.a6 = a;
            if (b != this.a6) {
                this.aw("ActualHeaderBackgroundColor", b, a);
            }
        }
        get b7() {
            return this.bg;
        }
        set b7(a) {
            let b = this.bg;
            this.bg = a;
            if (b != this.bg) {
                this.aw("HeaderCollapsedBackgroundColor", b, a);
            }
        }
        get b8() {
            return this.bh;
        }
        set b8(a) {
            let b = this.bh;
            this.bh = a;
            if (b != this.bh) {
                this.aw("HeaderExpandedBackgroundColor", b, a);
            }
        }
        get bn() {
            return this.a8;
        }
        set bn(a) {
            let b = this.a8;
            this.a8 = a;
            if (b != this.a8) {
                this.aw("ActualUmbraShadowColor", b, a);
            }
        }
        get bm() {
            return this.a7;
        }
        set bm(a) {
            let b = this.a7;
            this.a7 = a;
            if (b != this.a7) {
                this.aw("ActualPenumbraShadowColor", b, a);
            }
        }
        get bi() {
            return this.a3;
        }
        set bi(a) {
            let b = this.a3;
            this.a3 = a;
            if (b != this.a3) {
                this.aw("ActualAmbientShadowColor", b, a);
            }
        }
        f() {
            return new ExpansionPanelView();
        }
        ax(a, b, c) {
            switch (a) {
                case "CaptionTextColor":
                case "CaptionExpandedTextColor":
                case "CaptionCollapsedTextColor":
                case "DescriptionTextColor":
                case "DescriptionExpandedTextColor":
                case "DescriptionCollapsedTextColor":
                case "HeaderBackgroundColor":
                case "HeaderCollapsedBackgroundColor":
                case "HeaderExpandedBackgroundColor":
                case "Expanded":
                    let d = this.bl;
                    let e = this.b4();
                    let f = this.bj;
                    let g = this.b0();
                    let h = this.bk;
                    let i = this.b2();
                    let j = (d != e) || (f != g) || (h != i);
                    if (j) {
                        this.bl = e;
                        this.bj = g;
                        this.bk = i;
                    }
                    else if (a == "Expanded") {
                        this.g.ak();
                    }
                    break;
                case "Elevation":
                    this.q = this.s == -1 ? XExpansionPanel.r : this.s;
                    break;
                case "ActualElevation":
                case "ActualHeaderBackgroundColor":
                case "ActualCaptionTextColor":
                case "ActualDescriptionTextColor":
                case "ActualUmbraShadowColor":
                case "ActualPenumbraShadowColor":
                case "ActualAmbientShadowColor":
                case "Caption":
                case "Description":
                    this.g.ak();
                    break;
            }
        }
        h(a) {
            let b = this.bj;
            let c = this.b1(a);
            let d = a ? this.b() : this.a();
            let e = this.g.a(d);
            let f = [new AnimationKeyFrameProperty(7, b)];
            let g = [new AnimationKeyFrameProperty(7, c)];
            e.m(...f);
            e.m(...g);
            return KeyFrameAnimationFactory.f.c(e);
        }
        i(a) {
            let b = this.bk;
            let c = this.b3(a);
            let d = a ? this.b() : this.a();
            let e = this.g.b(d);
            let f = [new AnimationKeyFrameProperty(7, b)];
            let g = [new AnimationKeyFrameProperty(7, c)];
            e.m(...f);
            e.m(...g);
            return KeyFrameAnimationFactory.f.c(e);
        }
        j(a) {
            let b = this.bl;
            let c = this.b5(a);
            let d = a ? this.b() : this.a();
            let e = this.g.c(d);
            let f = [new AnimationKeyFrameProperty(2, b)];
            let g = [new AnimationKeyFrameProperty(2, c)];
            e.m(...f);
            e.m(...g);
            return KeyFrameAnimationFactory.f.c(e);
        }
        k(a) {
            let b = this.g.i();
            if (b <= 0) {
                b = 500;
            }
            let c = a ? -b : 0;
            let d = a ? 0 : -b;
            let e = a ? 0 : 1;
            let f = a ? 1 : 0;
            let g = a ? this.b() : this.a();
            let h = new TranslateTransform();
            h.k = c;
            let i = new TranslateTransform();
            i.k = d;
            let j = this.g.d(g);
            let k = [new AnimationKeyFrameProperty(14, h), new AnimationKeyFrameProperty(1, e)];
            let l = [new AnimationKeyFrameProperty(14, i), new AnimationKeyFrameProperty(1, f)];
            j.m(...k);
            j.m(...l);
            return KeyFrameAnimationFactory.f.c(j);
        }
        l(a) {
            let b = this.g.i();
            if (b <= 0) {
                b = 500;
            }
            let c = a ? 0 : b;
            let d = a ? b : 0;
            let e = a ? this.b() : this.a();
            let f = this.g.e(e);
            let g = [new AnimationKeyFrameProperty(10, c)];
            let h = [new AnimationKeyFrameProperty(10, d)];
            f.m(...g);
            f.m(...h);
            return KeyFrameAnimationFactory.f.c(f);
        }
        a() {
            let a = new AnimationKeyFrameEffectTiming();
            a.g = 300;
            a.b = 3;
            return a;
        }
        b() {
            let a = new AnimationKeyFrameEffectTiming();
            a.g = 300;
            a.b = 3;
            return a;
        }
        at() {
            this.g.u();
        }
        b0() {
            return this.b1(this.n);
        }
        b1(a) {
            let b;
            let c = null;
            c = a ? this.bp : this.bo;
            if (null != c) {
                b = c;
            }
            else {
                b = null != this.bq ? this.bq : XExpansionPanel.bs;
            }
            return b;
        }
        b2() {
            return this.b3(this.n);
        }
        b3(a) {
            let b;
            let c = null;
            c = a ? this.by : this.bx;
            if (null != c) {
                b = c;
            }
            else {
                b = null != this.bz ? this.bz : XExpansionPanel.bt;
            }
            return b;
        }
        b4() {
            return this.b5(this.n);
        }
        b5(a) {
            let b;
            let c = null;
            c = a ? this.b8 : this.b7;
            if (null != c) {
                b = c;
            }
            else {
                b = null != this.b6 ? this.b6 : XExpansionPanel.bu;
            }
            return b;
        }
        ar() {
            this.n = false;
        }
        destroy() {
            this.provideRenderer(null);
        }
        au() {
            this.n = true;
        }
        notifySizeChanged() {
        }
        provideHeader(a) {
            this.g.af(a);
        }
        provideContentAreaOuter(a) {
            this.g.ae(a);
        }
        provideContentAreaInner(a) {
            this.g.ad(a);
        }
        provideRenderer(a) {
            this.g.ac(a);
        }
        a2() {
            this.n = !this.n;
        }
    }
    XExpansionPanel.$t = /*@__PURE__*/ markType(XExpansionPanel, 'XExpansionPanel', Base.$, [INotifyPropertyChanged_$type]);
    XExpansionPanel.bs = /*@__PURE__*/ BrushUtil.h(188, 0, 0, 0);
    XExpansionPanel.bt = /*@__PURE__*/ BrushUtil.h(188, 0, 0, 0);
    XExpansionPanel.r = 2;
    XExpansionPanel.bu = /*@__PURE__*/ BrushUtil.h(255, 245, 245, 245);
    XExpansionPanel.bw = /*@__PURE__*/ BrushUtil.h(66, 0, 0, 0);
    XExpansionPanel.bv = /*@__PURE__*/ BrushUtil.h(30, 0, 0, 0);
    XExpansionPanel.br = /*@__PURE__*/ BrushUtil.h(20, 0, 0, 0);
    return XExpansionPanel;
})();
