/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, INotifyPropertyChanged_$type, PropertyChangedEventArgs, enumGetBox, markType, String_$type, typeCast } from "igniteui-react-core";
import { PropertyEditorValueType_$type } from "./PropertyEditorValueType";
import { PropertyEditorPropertyDescriptionButtonClickEventArgs } from "./PropertyEditorPropertyDescriptionButtonClickEventArgs";
import { PropertyEditorPropertyDescriptionChangedEventArgs } from "./PropertyEditorPropertyDescriptionChangedEventArgs";
import { PropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgs } from "./PropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgs";
import { ObservableCollection$1 } from "igniteui-react-core";
import { Dictionary$2 } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { stringEndsWith, stringContains, stringReplace } from "igniteui-react-core";
import { stringSplit } from "igniteui-react-core";
/**
 * @hidden
 */
export let PropertyEditorPropertyDescription = /*@__PURE__*/ (() => {
    class PropertyEditorPropertyDescription extends Base {
        constructor() {
            super(...arguments);
            this.aj = null;
            this.ah = null;
            this.o = 0;
            this.ai = null;
            this.q = false;
            this.ag = null;
            this.a = null;
            this.b = null;
            this.ad = null;
            this.w = NaN;
            this.t = NaN;
            this.u = NaN;
            this.v = NaN;
            this.x = NaN;
            this.f = null;
            this.h = new PropertyEditorDescriptionObjectCollection();
            this.l = new PropertyEditorPropertyDescriptionCollection();
            this.e = null;
            this.propertyChanged = null;
            this.buttonClicked = null;
            this.changed = null;
            this.targetPropertyUpdating = null;
        }
        get an() {
            return this.aj;
        }
        set an(a) {
            let b = this.aj;
            this.aj = a;
            if (this.aj != b) {
                this.aq("PropertyPath", b, a);
            }
        }
        get al() {
            return this.ah;
        }
        set al(a) {
            let b = this.ah;
            this.ah = a;
            if (this.ah != b) {
                this.aq("Label", b, a);
            }
        }
        get p() {
            return this.o;
        }
        set p(a) {
            let b = this.o;
            this.o = a;
            if (this.o != b) {
                this.aq("ValueType", enumGetBox(PropertyEditorValueType_$type, b), enumGetBox(PropertyEditorValueType_$type, a));
            }
        }
        get am() {
            return this.ai;
        }
        set am(a) {
            let b = this.ai;
            this.ai = a;
            if (this.ai != b) {
                this.aq("PropertyDescriptionType", b, a);
            }
        }
        get s() {
            return this.q;
        }
        set s(a) {
            let b = this.q;
            this.q = a;
            if (this.q != b) {
                this.aq("ShouldOverrideDefaultEditor", b, a);
            }
        }
        get ak() {
            return this.ag;
        }
        set ak(a) {
            let b = this.ag;
            this.ag = a;
            if (this.ag != b) {
                this.aq("ElementDescriptionType", b, a);
            }
        }
        get c() {
            return this.a;
        }
        set c(a) {
            let b = this.a;
            this.a = a;
            if (this.a != b) {
                this.aq("DropDownNames", b, a);
            }
        }
        get d() {
            return this.b;
        }
        set d(a) {
            let b = this.b;
            this.b = a;
            if (this.b != b) {
                this.aq("DropDownValues", b, a);
            }
        }
        get af() {
            return this.ad;
        }
        set af(a) {
            let b = this.ad;
            this.ad = a;
            if (this.ad != b) {
                this.aq("PrimitiveValue", b, a);
            }
        }
        get ab() {
            return this.w;
        }
        set ab(a) {
            let b = this.w;
            this.w = a;
            if (this.w != b) {
                this.aq("Min", b, a);
            }
        }
        get y() {
            return this.t;
        }
        set y(a) {
            let b = this.t;
            this.t = a;
            if (this.t != b) {
                this.aq("EditorWidth", b, a);
            }
        }
        get z() {
            return this.u;
        }
        set z(a) {
            let b = this.u;
            this.u = a;
            if (this.u != b) {
                this.aq("LabelWidth", b, a);
            }
        }
        get aa() {
            return this.v;
        }
        set aa(a) {
            let b = this.v;
            this.v = a;
            if (this.v != b) {
                this.aq("Max", b, a);
            }
        }
        get ac() {
            return this.x;
        }
        set ac(a) {
            let b = this.x;
            this.x = a;
            if (this.x != b) {
                this.aq("Step", b, a);
            }
        }
        get g() {
            return this.f;
        }
        set g(a) {
            let b = this.f;
            this.f = a;
            if (this.f != b) {
                this.aq("ComplexValue", b, a);
            }
        }
        get i() {
            return this.h;
        }
        set i(a) {
            let b = this.h;
            this.h = a;
            if (this.h != b) {
                this.aq("ComplexValues", b, a);
            }
        }
        get m() {
            return this.l;
        }
        set m(a) {
            let b = this.l;
            this.l = a;
            if (this.l != b) {
                this.aq("Properties", b, a);
            }
        }
        aq(a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs(a));
            }
        }
        r(a) {
            let b = false;
            if (a == null) {
                return false;
            }
            if (a.c != null && (this.c == null || !this.s)) {
                this.c = a.c;
            }
            if (a.d != null && (this.d == null || !this.s)) {
                this.d = a.d;
            }
            if (a.ak != null && (this.ak == null || !this.s)) {
                this.ak = a.ak;
            }
            if (a.am != null && (this.am == null || !this.s)) {
                this.am = a.am;
            }
            if (a.p != 0 && (this.p == 0 || !this.s)) {
                this.p = a.p;
                b = true;
            }
            return true;
        }
        ae(a, b) {
            if (b) {
                return this.e;
            }
            if (this.e != null) {
                return this.e.e(a, false);
            }
            return null;
        }
        ap() {
            if (this.buttonClicked != null) {
                this.buttonClicked(this, new PropertyEditorPropertyDescriptionButtonClickEventArgs());
            }
        }
        ao() {
            if (this.changed != null) {
                this.changed(this, ((() => {
                    let $ret = new PropertyEditorPropertyDescriptionChangedEventArgs();
                    $ret.newValue = this.af;
                    return $ret;
                })()));
            }
        }
        ar(a, b, c) {
            if (this.targetPropertyUpdating != null) {
                this.targetPropertyUpdating(this, ((() => {
                    let $ret = new PropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgs();
                    $ret.propertyPath = a;
                    $ret.target = b;
                    $ret.value = c;
                    return $ret;
                })()));
            }
        }
    }
    PropertyEditorPropertyDescription.$t = /*@__PURE__*/ markType(PropertyEditorPropertyDescription, 'PropertyEditorPropertyDescription', Base.$, [INotifyPropertyChanged_$type]);
    return PropertyEditorPropertyDescription;
})();
/**
 * @hidden
 */
export let PropertyEditorPropertyDescriptionCollection = /*@__PURE__*/ (() => {
    class PropertyEditorPropertyDescriptionCollection extends ObservableCollection$1 {
        constructor() {
            super(PropertyEditorPropertyDescription.$, 0);
        }
    }
    PropertyEditorPropertyDescriptionCollection.$t = /*@__PURE__*/ markType(PropertyEditorPropertyDescriptionCollection, 'PropertyEditorPropertyDescriptionCollection', /*@__PURE__*/ ObservableCollection$1.$.specialize(PropertyEditorPropertyDescription.$));
    return PropertyEditorPropertyDescriptionCollection;
})();
/**
 * @hidden
 */
export let PropertyEditorDataSource = /*@__PURE__*/ (() => {
    class PropertyEditorDataSource extends Base {
        constructor() {
            super(...arguments);
            this.k = null;
            this.a = null;
            this.g = null;
            this.propertyChanged = null;
            this.j = null;
        }
        get n() {
            return this.k;
        }
        set n(a) {
            let b = this.k;
            this.k = a;
            this.p("DescriptionType", b, this.k);
        }
        get b() {
            return this.a;
        }
        set b(a) {
            let b = this.a;
            this.a = a;
            this.p("Context", b, this.a);
        }
        get h() {
            return this.g;
        }
        set h(a) {
            let b = this.g;
            this.g = a;
            this.p("Data", b, this.g);
        }
        p(a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs(a));
            }
            this.q(a, b, c);
        }
        q(a, b, c) {
            switch (a) {
                case "DescriptionType":
                    this.r();
                    break;
                case "Context":
                    this.r();
                    break;
            }
        }
        static d(a, b, c) {
            let d = new PropertyEditorDataSource();
            d.j = c;
            d.b = a;
            d.n = b;
            d.j = null;
            return d;
        }
        f(a) {
            let b = new PropertyEditorPropertyDescription();
            b.an = a.propertyName;
            b.p = this.i(a);
            b.am = a.specificExternalType != null ? a.specificExternalType : a.specificType;
            if (a.knownType == 9) {
                b.ak = a.collectionElementType;
                if (this.j != null && this.j.containsKey(b.ak)) {
                    b.e = this.j.item(b.ak);
                }
                else {
                    b.e = PropertyEditorDataSource.d(this.a, b.ak, this.j);
                }
            }
            if (b.p == 8) {
                if (this.j != null && this.j.containsKey(b.am)) {
                    b.e = this.j.item(b.am);
                }
                else {
                    b.e = PropertyEditorDataSource.d(this.a, b.am, this.j);
                }
            }
            if (b.p == 15) {
                b.c = this.a.c(this.n, b.an);
                b.d = b.d;
            }
            return b;
        }
        i(a) {
            switch (a.knownType) {
                case 10: return 10;
                case 7: return 7;
                case 4: return 4;
                case 6: return 6;
                case 23: return 23;
                case 9: return 9;
                case 5: return 5;
                case 16: return 14;
                case 20: return 18;
                case 22: return 22;
                case 15: return 0;
                case 3: return 3;
                case 19: return 17;
                case 8:
                    if (a.specificExternalType == "string") {
                        return 15;
                    }
                    return 8;
                case 13: return 0;
                case 18: return 0;
                case 1: return 1;
                case 11: return 11;
                case 14: return 13;
                case 12: return 12;
                case 2: return 2;
                case 21: return 19;
                case 17: return 0;
                case 0: return 0;
            }
            return 0;
        }
        r() {
            let a = new PropertyEditorPropertyDescriptionCollection();
            if (this.n != null && this.b != null) {
                let b = false;
                if (this.j == null) {
                    b = true;
                    this.j = new Dictionary$2(String_$type, PropertyEditorDataSource.$, 0);
                }
                this.j.item(this.n, this);
                let c = this.b.b(this.n);
                if (c == null) {
                    return;
                }
                for (let d = 0; d < c.length; d++) {
                    if (stringEndsWith(c[d], "@names")) {
                        continue;
                    }
                    if (stringEndsWith(c[d], "@nameBinding")) {
                        continue;
                    }
                    if (stringEndsWith(c[d], "@ngQueryList")) {
                        continue;
                    }
                    if (stringEndsWith(c[d], "@mustSetInCode")) {
                        continue;
                    }
                    if (stringEndsWith(c[d], "@stringUnion")) {
                        continue;
                    }
                    let e = this.b.getMetadata(this.n, c[d]);
                    let f = this.f(e);
                    if (f.p == 0) {
                        continue;
                    }
                    a.add(f);
                }
                if (b) {
                    this.j = null;
                }
            }
            this.h = a;
        }
        e(a, b) {
            if (a == null) {
                return null;
            }
            let c = stringSplit(a, ['.', '['], 0);
            let d = new List$1(String_$type, 1, c);
            let e = null;
            let f = null;
            let g = null;
            while (d.count > 0) {
                let h = d._inner[0];
                d.removeAt(0);
                let i = false;
                if (stringContains(h, "]")) {
                    h = stringReplace(h, "]", "");
                    i = true;
                    let j = h.split(',');
                    h = j[0].trim();
                    if (stringContains(h, "as")) {
                        let k = h.indexOf("as");
                        g = h.substr(0, k).trim();
                        f = h.substr(k + 2).trim();
                    }
                    if (f != null && f != this.n) {
                        let l = this.c();
                        l.n = f;
                        e = l;
                        continue;
                    }
                }
                if (b) {
                    i = true;
                }
                if (e != null && typeCast(PropertyEditorPropertyDescription.$, e) !== null) {
                    let m = e.ae(h, i);
                    if (m == null) {
                        return null;
                    }
                    e = m;
                }
                else {
                    if (e != null) {
                        let n = e;
                        let o = n.e(h, i);
                        if (o == null) {
                            return null;
                        }
                        e = o;
                    }
                    else {
                        if (this.h == null) {
                            return null;
                        }
                        for (let p = 0; p < this.h.count; p++) {
                            if (Base.equalsStatic(this.h._inner[p].an, h)) {
                                e = this.h._inner[p];
                                break;
                            }
                        }
                        if (e == null) {
                            return null;
                        }
                    }
                }
            }
            return typeCast(PropertyEditorPropertyDescription.$, e);
        }
        c() {
            return ((() => {
                let $ret = new PropertyEditorDataSource();
                $ret.b = this.b;
                $ret.n = this.n;
                return $ret;
            })());
        }
    }
    PropertyEditorDataSource.$t = /*@__PURE__*/ markType(PropertyEditorDataSource, 'PropertyEditorDataSource', Base.$, [INotifyPropertyChanged_$type]);
    return PropertyEditorDataSource;
})();
/**
 * @hidden
 */
export let PropertyEditorDescriptionObject = /*@__PURE__*/ (() => {
    class PropertyEditorDescriptionObject extends Base {
        constructor() {
            super(...arguments);
            this.b = null;
            this.a = null;
        }
    }
    PropertyEditorDescriptionObject.$t = /*@__PURE__*/ markType(PropertyEditorDescriptionObject, 'PropertyEditorDescriptionObject');
    return PropertyEditorDescriptionObject;
})();
/**
 * @hidden
 */
export let PropertyEditorDescriptionObjectCollection = /*@__PURE__*/ (() => {
    class PropertyEditorDescriptionObjectCollection extends ObservableCollection$1 {
        constructor() {
            super(PropertyEditorDescriptionObject.$, 0);
        }
    }
    PropertyEditorDescriptionObjectCollection.$t = /*@__PURE__*/ markType(PropertyEditorDescriptionObjectCollection, 'PropertyEditorDescriptionObjectCollection', /*@__PURE__*/ ObservableCollection$1.$.specialize(PropertyEditorDescriptionObject.$));
    return PropertyEditorDescriptionObjectCollection;
})();
