import { IgCollection } from "igniteui-react-core";
import { markType } from "igniteui-react-core";
import { SyncableObservableCollection$2 } from "igniteui-react-core";
import { PropertyEditorPropertyDescription as PropertyEditorPropertyDescription_internal } from './PropertyEditorPropertyDescription';
import { IgrPropertyEditorPropertyDescription as IgrPropertyEditorPropertyDescription } from './igr-property-editor-property-description';
export class IgrHorizontalPropertyEditorPanelDataSource extends IgCollection {
    constructor(list) {
        super();
        if (!IgrPropertyEditorPropertyDescription.$type) {
            IgrPropertyEditorPropertyDescription.$type = markType(IgrPropertyEditorPropertyDescription, "IgrPropertyEditorPropertyDescription");
        }
        if (list) {
            for (let i = 0; i < list.length; i++) {
                this.add(list[i]);
            }
        }
    }
    _createInnerColl() {
        if (!IgrPropertyEditorPropertyDescription.$type) {
            IgrPropertyEditorPropertyDescription.$type = markType(IgrPropertyEditorPropertyDescription, "IgrPropertyEditorPropertyDescription");
        }
        let coll = new SyncableObservableCollection$2(IgrPropertyEditorPropertyDescription.$type, PropertyEditorPropertyDescription_internal.$type, 0);
        coll.compare = (ext, int) => {
            let comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = (ext) => {
            return ext._implementation;
        };
        coll.createFrom = (int) => {
            let ext = int.externalObject;
            if (!ext) {
                ext = new IgrPropertyEditorPropertyDescription(null);
                if (ext) {
                    if (!int.$type && ext._implementation.setNativeElement) {
                        ext._implementation.setNativeElement(int);
                    }
                    else {
                        ext._implementation = int;
                    }
                }
            }
            return ext;
        };
        return coll;
    }
}
