import { IgCollection } from "igniteui-react-core";
import { markType } from "igniteui-react-core";
import { SyncableObservableCollection$2 } from "igniteui-react-core";
import { PropertyEditorDescriptionObject as PropertyEditorDescriptionObject_internal } from './PropertyEditorDescriptionObject';
import { IgrPropertyEditorDescriptionObject as IgrPropertyEditorDescriptionObject } from './igr-property-editor-description-object';
export class IgrPropertyEditorDescriptionObjectCollection extends IgCollection {
    constructor(list) {
        super();
        if (!IgrPropertyEditorDescriptionObject.$type) {
            IgrPropertyEditorDescriptionObject.$type = markType(IgrPropertyEditorDescriptionObject, "IgrPropertyEditorDescriptionObject");
        }
        if (list) {
            for (let i = 0; i < list.length; i++) {
                this.add(list[i]);
            }
        }
    }
    _createInnerColl() {
        if (!IgrPropertyEditorDescriptionObject.$type) {
            IgrPropertyEditorDescriptionObject.$type = markType(IgrPropertyEditorDescriptionObject, "IgrPropertyEditorDescriptionObject");
        }
        let coll = new SyncableObservableCollection$2(IgrPropertyEditorDescriptionObject.$type, PropertyEditorDescriptionObject_internal.$type, 0);
        coll.compare = (ext, int) => {
            let comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = (ext) => {
            return ext._implementation;
        };
        coll.createFrom = (int) => {
            let ext = int.externalObject;
            if (!ext) {
                ext = new IgrPropertyEditorDescriptionObject();
                if (ext) {
                    if (!int.$type && ext._implementation.setNativeElement) {
                        ext._implementation.setNativeElement(int);
                    }
                    else {
                        ext._implementation = int;
                    }
                }
            }
            return ext;
        };
        return coll;
    }
}
