import { IgCollection } from "igniteui-react-core";
import { markType } from "igniteui-react-core";
import { SyncableObservableCollection$2 } from "igniteui-react-core";
import { ToolAction as ToolAction_internal } from './ToolAction';
import { IgrToolAction as IgrToolAction } from './igr-tool-action';
export class IgrToolActionCollection extends IgCollection {
    constructor(list) {
        super();
        if (!IgrToolAction.$type) {
            IgrToolAction.$type = markType(IgrToolAction, "IgrToolAction");
        }
        if (list) {
            for (let i = 0; i < list.length; i++) {
                this.add(list[i]);
            }
        }
    }
    _createInnerColl() {
        if (!IgrToolAction.$type) {
            IgrToolAction.$type = markType(IgrToolAction, "IgrToolAction");
        }
        let coll = new SyncableObservableCollection$2(IgrToolAction.$type, ToolAction_internal.$type, 0);
        coll.compare = (ext, int) => {
            let comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = (ext) => {
            return ext._implementation;
        };
        coll.createFrom = (int) => {
            let ext = int.externalObject;
            if (!ext) {
                ext = IgrToolAction._createFromInternal(int);
                if (ext) {
                    if (!int.$type && ext._implementation.setNativeElement) {
                        ext._implementation.setNativeElement(int);
                    }
                    else {
                        ext._implementation = int;
                    }
                }
            }
            return ext;
        };
        return coll;
    }
}
