import { ToolPanelContextChangedEventArgs as ToolPanelContextChangedEventArgs_internal } from "./ToolPanelContextChangedEventArgs";
export class IgrToolPanelContextChangedEventArgs {
    createImplementation() {
        return new ToolPanelContextChangedEventArgs_internal();
    }
    get nativeElement() {
        return this._implementation.nativeElement;
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    get id() {
        return this.i.c;
    }
    set id(v) {
        this.i.c = v;
    }
    get propertyName() {
        return this.i.d;
    }
    set propertyName(v) {
        this.i.d = v;
    }
    get oldValue() {
        return this.i.b;
    }
    set oldValue(v) {
        this.i.b = v;
    }
    get newValue() {
        return this.i.a;
    }
    set newValue(v) {
        this.i.a = v;
    }
}
