/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { IgrListPanelModule } from './igr-list-panel-module';
import { IgrToolActionLabelModule } from './igr-tool-action-label-module';
import { IgrToolActionCheckboxModule } from './igr-tool-action-checkbox-module';
import { IgrToolActionCheckboxListModule } from './igr-tool-action-checkbox-list-module';
import { IgrToolActionGroupHeaderModule } from './igr-tool-action-group-header-module';
import { IgrToolActionNumberInputModule } from './igr-tool-action-number-input-module';
import { IgrToolActionIconButtonModule } from './igr-tool-action-icon-button-module';
import { IgrToolActionIconMenuModule } from './igr-tool-action-icon-menu-module';
import { IgrToolActionSeparatorModule } from './igr-tool-action-separator-module';
import { IgrToolActionSubPanelModule } from './igr-tool-action-sub-panel-module';
import { IgrToolActionRadioModule } from './igr-tool-action-radio-module';
import { IgrToolActionButtonModule } from './igr-tool-action-button-module';
import { IgrXInputGroupModule } from "igniteui-react-inputs";
import { IgrXCheckboxModule } from "igniteui-react-inputs";
import { IgrXButtonModule } from "igniteui-react-inputs";
import { IgrXIconModule } from "igniteui-react-inputs";
import { IgrToolPanel } from './igr-tool-panel';
import { ToolPanel } from './ToolPanel';
import { TypeRegistrar } from "igniteui-react-core";
export class IgrToolPanelModule {
    static register() {
        IgrListPanelModule.register();
        IgrToolActionLabelModule.register();
        IgrToolActionCheckboxModule.register();
        IgrToolActionCheckboxListModule.register();
        IgrToolActionGroupHeaderModule.register();
        IgrToolActionNumberInputModule.register();
        IgrToolActionIconButtonModule.register();
        IgrToolActionIconMenuModule.register();
        IgrToolActionSeparatorModule.register();
        IgrToolActionSubPanelModule.register();
        IgrToolActionRadioModule.register();
        IgrToolActionButtonModule.register();
        IgrXInputGroupModule.register();
        IgrXCheckboxModule.register();
        IgrXButtonModule.register();
        IgrXIconModule.register();
        TypeRegistrar.registerCons('IgrToolPanel', IgrToolPanel);
        TypeRegistrar.registerCons('IgrToolPanel', IgrToolPanel);
        TypeRegistrar.register('ToolPanel', ToolPanel.$type);
    }
}
