/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { Base, INotifyPropertyChanged_$type, PropertyChangedEventArgs, enumGetBox, markType, String_$type, typeCast } from "igniteui-react-core";
import { PropertyEditorValueType_$type } from "./PropertyEditorValueType";
import { PropertyEditorPropertyDescriptionButtonClickEventArgs } from "./PropertyEditorPropertyDescriptionButtonClickEventArgs";
import { PropertyEditorPropertyDescriptionChangedEventArgs } from "./PropertyEditorPropertyDescriptionChangedEventArgs";
import { PropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgs } from "./PropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgs";
import { ObservableCollection$1 } from "igniteui-react-core";
import { Dictionary$2 } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { stringEndsWith, stringContains, stringReplace } from "igniteui-react-core";
import { stringSplit } from "igniteui-react-core";
/**
 * @hidden
 */
var PropertyEditorPropertyDescription = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PropertyEditorPropertyDescription, _super);
    function PropertyEditorPropertyDescription() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.aj = null;
        _this.ah = null;
        _this.o = 0;
        _this.ai = null;
        _this.q = false;
        _this.ag = null;
        _this.a = null;
        _this.b = null;
        _this.ad = null;
        _this.w = NaN;
        _this.t = NaN;
        _this.u = NaN;
        _this.v = NaN;
        _this.x = NaN;
        _this.f = null;
        _this.h = new PropertyEditorDescriptionObjectCollection();
        _this.l = new PropertyEditorPropertyDescriptionCollection();
        _this.e = null;
        _this.propertyChanged = null;
        _this.buttonClicked = null;
        _this.changed = null;
        _this.targetPropertyUpdating = null;
        return _this;
    }
    Object.defineProperty(PropertyEditorPropertyDescription.prototype, "an", {
        get: function () {
            return this.aj;
        },
        set: function (a) {
            var b = this.aj;
            this.aj = a;
            if (this.aj != b) {
                this.aq("PropertyPath", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PropertyEditorPropertyDescription.prototype, "al", {
        get: function () {
            return this.ah;
        },
        set: function (a) {
            var b = this.ah;
            this.ah = a;
            if (this.ah != b) {
                this.aq("Label", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PropertyEditorPropertyDescription.prototype, "p", {
        get: function () {
            return this.o;
        },
        set: function (a) {
            var b = this.o;
            this.o = a;
            if (this.o != b) {
                this.aq("ValueType", enumGetBox(PropertyEditorValueType_$type, b), enumGetBox(PropertyEditorValueType_$type, a));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PropertyEditorPropertyDescription.prototype, "am", {
        get: function () {
            return this.ai;
        },
        set: function (a) {
            var b = this.ai;
            this.ai = a;
            if (this.ai != b) {
                this.aq("PropertyDescriptionType", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PropertyEditorPropertyDescription.prototype, "s", {
        get: function () {
            return this.q;
        },
        set: function (a) {
            var b = this.q;
            this.q = a;
            if (this.q != b) {
                this.aq("ShouldOverrideDefaultEditor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PropertyEditorPropertyDescription.prototype, "ak", {
        get: function () {
            return this.ag;
        },
        set: function (a) {
            var b = this.ag;
            this.ag = a;
            if (this.ag != b) {
                this.aq("ElementDescriptionType", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PropertyEditorPropertyDescription.prototype, "c", {
        get: function () {
            return this.a;
        },
        set: function (a) {
            var b = this.a;
            this.a = a;
            if (this.a != b) {
                this.aq("DropDownNames", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PropertyEditorPropertyDescription.prototype, "d", {
        get: function () {
            return this.b;
        },
        set: function (a) {
            var b = this.b;
            this.b = a;
            if (this.b != b) {
                this.aq("DropDownValues", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PropertyEditorPropertyDescription.prototype, "af", {
        get: function () {
            return this.ad;
        },
        set: function (a) {
            var b = this.ad;
            this.ad = a;
            if (this.ad != b) {
                this.aq("PrimitiveValue", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PropertyEditorPropertyDescription.prototype, "ab", {
        get: function () {
            return this.w;
        },
        set: function (a) {
            var b = this.w;
            this.w = a;
            if (this.w != b) {
                this.aq("Min", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PropertyEditorPropertyDescription.prototype, "y", {
        get: function () {
            return this.t;
        },
        set: function (a) {
            var b = this.t;
            this.t = a;
            if (this.t != b) {
                this.aq("EditorWidth", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PropertyEditorPropertyDescription.prototype, "z", {
        get: function () {
            return this.u;
        },
        set: function (a) {
            var b = this.u;
            this.u = a;
            if (this.u != b) {
                this.aq("LabelWidth", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PropertyEditorPropertyDescription.prototype, "aa", {
        get: function () {
            return this.v;
        },
        set: function (a) {
            var b = this.v;
            this.v = a;
            if (this.v != b) {
                this.aq("Max", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PropertyEditorPropertyDescription.prototype, "ac", {
        get: function () {
            return this.x;
        },
        set: function (a) {
            var b = this.x;
            this.x = a;
            if (this.x != b) {
                this.aq("Step", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PropertyEditorPropertyDescription.prototype, "g", {
        get: function () {
            return this.f;
        },
        set: function (a) {
            var b = this.f;
            this.f = a;
            if (this.f != b) {
                this.aq("ComplexValue", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PropertyEditorPropertyDescription.prototype, "i", {
        get: function () {
            return this.h;
        },
        set: function (a) {
            var b = this.h;
            this.h = a;
            if (this.h != b) {
                this.aq("ComplexValues", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PropertyEditorPropertyDescription.prototype, "m", {
        get: function () {
            return this.l;
        },
        set: function (a) {
            var b = this.l;
            this.l = a;
            if (this.l != b) {
                this.aq("Properties", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    PropertyEditorPropertyDescription.prototype.aq = function (a, b, c) {
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
    };
    PropertyEditorPropertyDescription.prototype.r = function (a) {
        var b = false;
        if (a == null) {
            return false;
        }
        if (a.c != null && (this.c == null || !this.s)) {
            this.c = a.c;
        }
        if (a.d != null && (this.d == null || !this.s)) {
            this.d = a.d;
        }
        if (a.ak != null && (this.ak == null || !this.s)) {
            this.ak = a.ak;
        }
        if (a.am != null && (this.am == null || !this.s)) {
            this.am = a.am;
        }
        if (a.p != 0 && (this.p == 0 || !this.s)) {
            this.p = a.p;
            b = true;
        }
        return true;
    };
    PropertyEditorPropertyDescription.prototype.ae = function (a, b) {
        if (b) {
            return this.e;
        }
        if (this.e != null) {
            return this.e.e(a, false);
        }
        return null;
    };
    PropertyEditorPropertyDescription.prototype.ap = function () {
        if (this.buttonClicked != null) {
            this.buttonClicked(this, new PropertyEditorPropertyDescriptionButtonClickEventArgs());
        }
    };
    PropertyEditorPropertyDescription.prototype.ao = function () {
        var _this = this;
        if (this.changed != null) {
            this.changed(this, ((function () {
                var $ret = new PropertyEditorPropertyDescriptionChangedEventArgs();
                $ret.newValue = _this.af;
                return $ret;
            })()));
        }
    };
    PropertyEditorPropertyDescription.prototype.ar = function (a, b, c) {
        if (this.targetPropertyUpdating != null) {
            this.targetPropertyUpdating(this, ((function () {
                var $ret = new PropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgs();
                $ret.propertyPath = a;
                $ret.target = b;
                $ret.value = c;
                return $ret;
            })()));
        }
    };
    PropertyEditorPropertyDescription.$t = markType(PropertyEditorPropertyDescription, 'PropertyEditorPropertyDescription', Base.$, [INotifyPropertyChanged_$type]);
    return PropertyEditorPropertyDescription;
}(Base));
export { PropertyEditorPropertyDescription };
/**
 * @hidden
 */
var PropertyEditorPropertyDescriptionCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PropertyEditorPropertyDescriptionCollection, _super);
    function PropertyEditorPropertyDescriptionCollection() {
        return _super.call(this, PropertyEditorPropertyDescription.$, 0) || this;
    }
    PropertyEditorPropertyDescriptionCollection.$t = markType(PropertyEditorPropertyDescriptionCollection, 'PropertyEditorPropertyDescriptionCollection', ObservableCollection$1.$.specialize(PropertyEditorPropertyDescription.$));
    return PropertyEditorPropertyDescriptionCollection;
}(ObservableCollection$1));
export { PropertyEditorPropertyDescriptionCollection };
/**
 * @hidden
 */
var PropertyEditorDataSource = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PropertyEditorDataSource, _super);
    function PropertyEditorDataSource() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.k = null;
        _this.a = null;
        _this.g = null;
        _this.propertyChanged = null;
        _this.j = null;
        return _this;
    }
    Object.defineProperty(PropertyEditorDataSource.prototype, "n", {
        get: function () {
            return this.k;
        },
        set: function (a) {
            var b = this.k;
            this.k = a;
            this.p("DescriptionType", b, this.k);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PropertyEditorDataSource.prototype, "b", {
        get: function () {
            return this.a;
        },
        set: function (a) {
            var b = this.a;
            this.a = a;
            this.p("Context", b, this.a);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PropertyEditorDataSource.prototype, "h", {
        get: function () {
            return this.g;
        },
        set: function (a) {
            var b = this.g;
            this.g = a;
            this.p("Data", b, this.g);
        },
        enumerable: false,
        configurable: true
    });
    PropertyEditorDataSource.prototype.p = function (a, b, c) {
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
        this.q(a, b, c);
    };
    PropertyEditorDataSource.prototype.q = function (a, b, c) {
        switch (a) {
            case "DescriptionType":
                this.r();
                break;
            case "Context":
                this.r();
                break;
        }
    };
    PropertyEditorDataSource.d = function (a, b, c) {
        var d = new PropertyEditorDataSource();
        d.j = c;
        d.b = a;
        d.n = b;
        d.j = null;
        return d;
    };
    PropertyEditorDataSource.prototype.f = function (a) {
        var b = new PropertyEditorPropertyDescription();
        b.an = a.propertyName;
        b.p = this.i(a);
        b.am = a.specificExternalType != null ? a.specificExternalType : a.specificType;
        if (a.knownType == 9) {
            b.ak = a.collectionElementType;
            if (this.j != null && this.j.containsKey(b.ak)) {
                b.e = this.j.item(b.ak);
            }
            else {
                b.e = PropertyEditorDataSource.d(this.a, b.ak, this.j);
            }
        }
        if (b.p == 8) {
            if (this.j != null && this.j.containsKey(b.am)) {
                b.e = this.j.item(b.am);
            }
            else {
                b.e = PropertyEditorDataSource.d(this.a, b.am, this.j);
            }
        }
        if (b.p == 15) {
            b.c = this.a.c(this.n, b.an);
            b.d = b.d;
        }
        return b;
    };
    PropertyEditorDataSource.prototype.i = function (a) {
        switch (a.knownType) {
            case 10: return 10;
            case 7: return 7;
            case 4: return 4;
            case 6: return 6;
            case 23: return 23;
            case 9: return 9;
            case 5: return 5;
            case 16: return 14;
            case 20: return 18;
            case 22: return 22;
            case 15: return 0;
            case 3: return 3;
            case 19: return 17;
            case 8:
                if (a.specificExternalType == "string") {
                    return 15;
                }
                return 8;
            case 13: return 0;
            case 18: return 0;
            case 1: return 1;
            case 11: return 11;
            case 14: return 13;
            case 12: return 12;
            case 2: return 2;
            case 21: return 19;
            case 17: return 0;
            case 0: return 0;
        }
        return 0;
    };
    PropertyEditorDataSource.prototype.r = function () {
        var a = new PropertyEditorPropertyDescriptionCollection();
        if (this.n != null && this.b != null) {
            var b = false;
            if (this.j == null) {
                b = true;
                this.j = new Dictionary$2(String_$type, PropertyEditorDataSource.$, 0);
            }
            this.j.item(this.n, this);
            var c = this.b.b(this.n);
            if (c == null) {
                return;
            }
            for (var d = 0; d < c.length; d++) {
                if (stringEndsWith(c[d], "@names")) {
                    continue;
                }
                if (stringEndsWith(c[d], "@nameBinding")) {
                    continue;
                }
                if (stringEndsWith(c[d], "@ngQueryList")) {
                    continue;
                }
                if (stringEndsWith(c[d], "@mustSetInCode")) {
                    continue;
                }
                if (stringEndsWith(c[d], "@stringUnion")) {
                    continue;
                }
                var e = this.b.getMetadata(this.n, c[d]);
                var f = this.f(e);
                if (f.p == 0) {
                    continue;
                }
                a.add(f);
            }
            if (b) {
                this.j = null;
            }
        }
        this.h = a;
    };
    PropertyEditorDataSource.prototype.e = function (a, b) {
        if (a == null) {
            return null;
        }
        var c = stringSplit(a, ['.', '['], 0);
        var d = new List$1(String_$type, 1, c);
        var e = null;
        var f = null;
        var g = null;
        while (d.count > 0) {
            var h = d._inner[0];
            d.removeAt(0);
            var i = false;
            if (stringContains(h, "]")) {
                h = stringReplace(h, "]", "");
                i = true;
                var j = h.split(',');
                h = j[0].trim();
                if (stringContains(h, "as")) {
                    var k = h.indexOf("as");
                    g = h.substr(0, k).trim();
                    f = h.substr(k + 2).trim();
                }
                if (f != null && f != this.n) {
                    var l = this.c();
                    l.n = f;
                    e = l;
                    continue;
                }
            }
            if (b) {
                i = true;
            }
            if (e != null && typeCast(PropertyEditorPropertyDescription.$, e) !== null) {
                var m = e.ae(h, i);
                if (m == null) {
                    return null;
                }
                e = m;
            }
            else {
                if (e != null) {
                    var n = e;
                    var o = n.e(h, i);
                    if (o == null) {
                        return null;
                    }
                    e = o;
                }
                else {
                    if (this.h == null) {
                        return null;
                    }
                    for (var p = 0; p < this.h.count; p++) {
                        if (Base.equalsStatic(this.h._inner[p].an, h)) {
                            e = this.h._inner[p];
                            break;
                        }
                    }
                    if (e == null) {
                        return null;
                    }
                }
            }
        }
        return typeCast(PropertyEditorPropertyDescription.$, e);
    };
    PropertyEditorDataSource.prototype.c = function () {
        var _this = this;
        return ((function () {
            var $ret = new PropertyEditorDataSource();
            $ret.b = _this.b;
            $ret.n = _this.n;
            return $ret;
        })());
    };
    PropertyEditorDataSource.$t = markType(PropertyEditorDataSource, 'PropertyEditorDataSource', Base.$, [INotifyPropertyChanged_$type]);
    return PropertyEditorDataSource;
}(Base));
export { PropertyEditorDataSource };
/**
 * @hidden
 */
var PropertyEditorDescriptionObject = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PropertyEditorDescriptionObject, _super);
    function PropertyEditorDescriptionObject() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.b = null;
        _this.a = null;
        return _this;
    }
    PropertyEditorDescriptionObject.$t = markType(PropertyEditorDescriptionObject, 'PropertyEditorDescriptionObject');
    return PropertyEditorDescriptionObject;
}(Base));
export { PropertyEditorDescriptionObject };
/**
 * @hidden
 */
var PropertyEditorDescriptionObjectCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PropertyEditorDescriptionObjectCollection, _super);
    function PropertyEditorDescriptionObjectCollection() {
        return _super.call(this, PropertyEditorDescriptionObject.$, 0) || this;
    }
    PropertyEditorDescriptionObjectCollection.$t = markType(PropertyEditorDescriptionObjectCollection, 'PropertyEditorDescriptionObjectCollection', ObservableCollection$1.$.specialize(PropertyEditorDescriptionObject.$));
    return PropertyEditorDescriptionObjectCollection;
}(ObservableCollection$1));
export { PropertyEditorDescriptionObjectCollection };
