/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { Base, markType } from "igniteui-react-core";
import { IVisualData_$type } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { ToolActionVisualData } from "./ToolActionVisualData";
import { StringBuilder } from "igniteui-react-core";
/**
 * @hidden
 */
var ToolPanelVisualData = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ToolPanelVisualData, _super);
    function ToolPanelVisualData() {
        var _this = _super.call(this) || this;
        _this.b = null;
        _this.c = null;
        _this.a = null;
        _this.b = new List$1(ToolActionVisualData.$, 0);
        _this.c = new List$1(ToolPanelDropdownMenuVisualData.$, 0);
        return _this;
    }
    ToolPanelVisualData.prototype.serialize = function () {
        var a = new StringBuilder(0);
        a.u("{");
        a.u("actions: [");
        if (this.b.count > 0) {
            for (var b = 0; b < this.b.count; b++) {
                var c = this.b._inner[b].serialize();
                a = b < this.b.count - 1 ? a.u(c + ", ") : a.l(c);
            }
        }
        a.u("], ");
        a.u("dropdowns: [");
        if (this.c.count > 0) {
            for (var d = 0; d < this.c.count; d++) {
                var e = this.c._inner[d].serialize();
                a = d < this.c.count - 1 ? a.l(e + ", ") : a.l(e);
            }
        }
        a.u("], ");
        a.u("panel: " + this.a.serialize());
        a.u("]");
        a.u("}");
        return a.toString();
    };
    ToolPanelVisualData.$t = markType(ToolPanelVisualData, 'ToolPanelVisualData', Base.$, [IVisualData_$type]);
    return ToolPanelVisualData;
}(Base));
export { ToolPanelVisualData };
/**
 * @hidden
 */
var ToolPanelDropdownMenuVisualData = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ToolPanelDropdownMenuVisualData, _super);
    function ToolPanelDropdownMenuVisualData() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.a = null;
        return _this;
    }
    ToolPanelDropdownMenuVisualData.prototype.serialize = function () {
        var a = new StringBuilder(0);
        a.u("{");
        if (this.a != null) {
            a.u("toolPanel: " + this.a.serialize() + ", ");
        }
        a.u("}");
        return a.toString();
    };
    ToolPanelDropdownMenuVisualData.$t = markType(ToolPanelDropdownMenuVisualData, 'ToolPanelDropdownMenuVisualData', Base.$, [IVisualData_$type]);
    return ToolPanelDropdownMenuVisualData;
}(Base));
export { ToolPanelDropdownMenuVisualData };
