import { __extends } from "tslib";
import { IgCollection } from "igniteui-react-core";
import { markType } from "igniteui-react-core";
import { SyncableObservableCollection$2 } from "igniteui-react-core";
import { PropertyEditorPropertyDescription as PropertyEditorPropertyDescription_internal } from './PropertyEditorPropertyDescription';
import { IgrPropertyEditorPropertyDescription as IgrPropertyEditorPropertyDescription } from './igr-property-editor-property-description';
var IgrHorizontalPropertyEditorPanelDataSource = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrHorizontalPropertyEditorPanelDataSource, _super);
    function IgrHorizontalPropertyEditorPanelDataSource(list) {
        var _this = _super.call(this) || this;
        if (!IgrPropertyEditorPropertyDescription.$type) {
            IgrPropertyEditorPropertyDescription.$type = markType(IgrPropertyEditorPropertyDescription, "IgrPropertyEditorPropertyDescription");
        }
        if (list) {
            for (var i = 0; i < list.length; i++) {
                _this.add(list[i]);
            }
        }
        return _this;
    }
    IgrHorizontalPropertyEditorPanelDataSource.prototype._createInnerColl = function () {
        if (!IgrPropertyEditorPropertyDescription.$type) {
            IgrPropertyEditorPropertyDescription.$type = markType(IgrPropertyEditorPropertyDescription, "IgrPropertyEditorPropertyDescription");
        }
        var coll = new SyncableObservableCollection$2(IgrPropertyEditorPropertyDescription.$type, PropertyEditorPropertyDescription_internal.$type, 0);
        coll.compare = function (ext, int) {
            var comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = function (ext) {
            return ext._implementation;
        };
        coll.createFrom = function (int) {
            var ext = int.externalObject;
            if (!ext) {
                ext = new IgrPropertyEditorPropertyDescription(null);
                if (ext) {
                    if (!int.$type && ext._implementation.setNativeElement) {
                        ext._implementation.setNativeElement(int);
                    }
                    else {
                        ext._implementation = int;
                    }
                }
            }
            return ext;
        };
        return coll;
    };
    return IgrHorizontalPropertyEditorPanelDataSource;
}(IgCollection));
export { IgrHorizontalPropertyEditorPanelDataSource };
