import { IgrListPanelItemModel } from "./igr-list-panel-item-model";
import { ListPanelTemplateItemUpdatingEventArgs as ListPanelTemplateItemUpdatingEventArgs_internal } from "./ListPanelTemplateItemUpdatingEventArgs";
var IgrListPanelTemplateItemUpdatingEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrListPanelTemplateItemUpdatingEventArgs() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrListPanelTemplateItemUpdatingEventArgs.prototype.createImplementation = function () {
        return new ListPanelTemplateItemUpdatingEventArgs_internal();
    };
    Object.defineProperty(IgrListPanelTemplateItemUpdatingEventArgs.prototype, "nativeElement", {
        get: function () {
            return this._implementation.nativeElement;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrListPanelTemplateItemUpdatingEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrListPanelTemplateItemUpdatingEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrListPanelTemplateItemUpdatingEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrListPanelTemplateItemUpdatingEventArgs.prototype, "model", {
        get: function () {
            var r = this.i.a;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = new IgrListPanelItemModel();
                if (r.$type) {
                    e._implementation = r;
                }
                else {
                    if (e.i.setNativeElement) {
                        e.i.setNativeElement(r);
                    }
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.a = null : this.i.a = v.i;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrListPanelTemplateItemUpdatingEventArgs.prototype, "content", {
        get: function () {
            return this.i.c;
        },
        set: function (v) {
            this.i.c = v;
        },
        enumerable: false,
        configurable: true
    });
    return IgrListPanelTemplateItemUpdatingEventArgs;
}());
export { IgrListPanelTemplateItemUpdatingEventArgs };
