import { OnCollapsedEventArgs as OnCollapsedEventArgs_internal } from "./OnCollapsedEventArgs";
var IgrOnCollapsedEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrOnCollapsedEventArgs() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrOnCollapsedEventArgs.prototype.createImplementation = function () {
        return new OnCollapsedEventArgs_internal();
    };
    Object.defineProperty(IgrOnCollapsedEventArgs.prototype, "nativeElement", {
        get: function () {
            return this._implementation.nativeElement;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrOnCollapsedEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrOnCollapsedEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrOnCollapsedEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    return IgrOnCollapsedEventArgs;
}());
export { IgrOnCollapsedEventArgs };
