import { __extends } from "tslib";
import { IgrToolAction } from "./igr-tool-action";
import { ToolActionIconButton } from "./ToolActionIconButton";
var IgrToolActionIconButton = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrToolActionIconButton, _super);
    function IgrToolActionIconButton(props) {
        return _super.call(this, props) || this;
    }
    IgrToolActionIconButton.prototype.createImplementation = function () {
        return new ToolActionIconButton();
    };
    Object.defineProperty(IgrToolActionIconButton.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionIconButton.prototype, "tooltipDelay", {
        /**
         * Gets or sets how long it takes before the tooltip is displayed (in milliseconds).
        */
        get: function () {
            return this.i.ib;
        },
        set: function (v) {
            this.i.ib = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionIconButton.prototype, "actualTooltipDelay", {
        /**
         * Gets the actual delay before the tooltip is displayed (in milliseconds).
        */
        get: function () {
            return this.i.ia;
        },
        set: function (v) {
            this.i.ia = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionIconButton.prototype, "contentPaddingLeft", {
        get: function () {
            return this.i.h3;
        },
        set: function (v) {
            this.i.h3 = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionIconButton.prototype, "actualContentPaddingLeft", {
        get: function () {
            return this.i.hz;
        },
        set: function (v) {
            this.i.hz = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionIconButton.prototype, "contentPaddingTop", {
        get: function () {
            return this.i.h5;
        },
        set: function (v) {
            this.i.h5 = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionIconButton.prototype, "actualContentPaddingTop", {
        get: function () {
            return this.i.h1;
        },
        set: function (v) {
            this.i.h1 = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionIconButton.prototype, "contentPaddingRight", {
        get: function () {
            return this.i.h4;
        },
        set: function (v) {
            this.i.h4 = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionIconButton.prototype, "actualContentPaddingRight", {
        get: function () {
            return this.i.h0;
        },
        set: function (v) {
            this.i.h0 = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionIconButton.prototype, "contentPaddingBottom", {
        get: function () {
            return this.i.h2;
        },
        set: function (v) {
            this.i.h2 = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrToolActionIconButton.prototype, "actualContentPaddingBottom", {
        get: function () {
            return this.i.hy;
        },
        set: function (v) {
            this.i.hy = +v;
        },
        enumerable: false,
        configurable: true
    });
    IgrToolActionIconButton.prototype.cleanUp = function () {
        this.i.e3();
    };
    IgrToolActionIconButton.prototype.openSubMenu = function () {
        this.i.fy();
    };
    IgrToolActionIconButton.prototype.closeSubmenu = function () {
        this.i.e5();
    };
    IgrToolActionIconButton.prototype.exportVisualData = function () {
        var iv = this.i.cn();
        return (iv);
    };
    return IgrToolActionIconButton;
}(IgrToolAction));
export { IgrToolActionIconButton };
