import { Base, Type, INotifyPropertyChanged, PropertyChangedEventArgs } from "igniteui-react-core";
import { DomWrapper, DomRenderer } from "igniteui-react-core";
import { AnimationKeyFrameEffect } from "igniteui-react-core";
import { AnimationKeyFrameEffectTiming } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { OnCollapsedEventArgs } from "./OnCollapsedEventArgs";
import { OnExpandedEventArgs } from "./OnExpandedEventArgs";
/**
 * @hidden
 */
export declare class ExpansionPanelView extends Base {
    static $t: Type;
    private j;
    private q;
    private g;
    private f;
    private p;
    private l;
    private o;
    private n;
    private m;
    private static readonly al;
    private static readonly t;
    private static readonly s;
    protected get r(): DomWrapper;
    protected get h(): XExpansionPanel;
    protected get k(): DomRenderer;
    protected ab(): void;
    aj(): void;
    ak(): void;
    a(a: AnimationKeyFrameEffectTiming): AnimationKeyFrameEffect;
    b(a: AnimationKeyFrameEffectTiming): AnimationKeyFrameEffect;
    c(a: AnimationKeyFrameEffectTiming): AnimationKeyFrameEffect;
    d(a: AnimationKeyFrameEffectTiming): AnimationKeyFrameEffect;
    e(a: AnimationKeyFrameEffectTiming): AnimationKeyFrameEffect;
    u(): void;
    i(): number;
    ac(a: DomRenderer): void;
    private ag;
    private ah;
    private ai;
    protected y(a: DomWrapper): void;
    z(a: XExpansionPanel): void;
    aa(): void;
    af(a: any): void;
    v(a: DomWrapper): void;
    ae(a: any): void;
    ad(a: any): void;
    private w;
    private x;
}
/**
 * @hidden
 */
export declare class XExpansionPanel extends Base implements INotifyPropertyChanged {
    static $t: Type;
    private c;
    constructor();
    onCollapsed: (sender: any, args: OnCollapsedEventArgs) => void;
    onExpanded: (sender: any, args: OnExpandedEventArgs) => void;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    protected aw(a: string, b: any, c: any): void;
    g: ExpansionPanelView;
    private aa;
    get ab(): string;
    set ab(a: string);
    private bb;
    get bq(): Brush;
    set bq(a: Brush);
    static bs: Brush;
    private a4;
    get bj(): Brush;
    set bj(a: Brush);
    private a9;
    get bo(): Brush;
    set bo(a: Brush);
    private ba;
    get bp(): Brush;
    set bp(a: Brush);
    private ag;
    get ah(): string;
    set ah(a: string);
    private be;
    get bz(): Brush;
    set bz(a: Brush);
    static bt: Brush;
    private a5;
    get bk(): Brush;
    set bk(a: Brush);
    private bc;
    get bx(): Brush;
    set bx(a: Brush);
    private bd;
    get by(): Brush;
    set by(a: Brush);
    private p;
    get s(): number;
    set s(a: number);
    static r: number;
    private o;
    get q(): number;
    set q(a: number);
    private m;
    get n(): boolean;
    set n(a: boolean);
    private bf;
    get b6(): Brush;
    set b6(a: Brush);
    static bu: Brush;
    private a6;
    get bl(): Brush;
    set bl(a: Brush);
    private bg;
    get b7(): Brush;
    set b7(a: Brush);
    private bh;
    get b8(): Brush;
    set b8(a: Brush);
    static bw: Brush;
    private a8;
    get bn(): Brush;
    set bn(a: Brush);
    static bv: Brush;
    private a7;
    get bm(): Brush;
    set bm(a: Brush);
    static br: Brush;
    private a3;
    get bi(): Brush;
    set bi(a: Brush);
    protected f(): ExpansionPanelView;
    protected ax(a: string, b: any, c: any): void;
    private h;
    private i;
    private j;
    private k;
    private l;
    private a;
    private b;
    private at;
    private b0;
    private b1;
    private b2;
    private b3;
    private b4;
    private b5;
    ar(): void;
    destroy(): void;
    au(): void;
    notifySizeChanged(): void;
    provideHeader(a: any): void;
    provideContentAreaOuter(a: any): void;
    provideContentAreaInner(a: any): void;
    provideRenderer(a: DomRenderer): void;
    a2(): void;
}
