import { Base, INotifyPropertyChanged, PropertyChangedEventArgs, Type } from "igniteui-react-core";
import { PropertyEditorValueType } from "./PropertyEditorValueType";
import { PropertyEditorPropertyDescriptionButtonClickEventArgs } from "./PropertyEditorPropertyDescriptionButtonClickEventArgs";
import { PropertyEditorPropertyDescriptionChangedEventArgs } from "./PropertyEditorPropertyDescriptionChangedEventArgs";
import { PropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgs } from "./PropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgs";
import { ObservableCollection$1 } from "igniteui-react-core";
import { TypeDescriptionContext } from "igniteui-react-core";
import { Dictionary$2 } from "igniteui-react-core";
/**
 * @hidden
 */
export declare class PropertyEditorPropertyDescription extends Base implements INotifyPropertyChanged {
    static $t: Type;
    private aj;
    get an(): string;
    set an(a: string);
    private ah;
    get al(): string;
    set al(a: string);
    private o;
    get p(): PropertyEditorValueType;
    set p(a: PropertyEditorValueType);
    private ai;
    get am(): string;
    set am(a: string);
    private q;
    get s(): boolean;
    set s(a: boolean);
    private ag;
    get ak(): string;
    set ak(a: string);
    private a;
    get c(): string[];
    set c(a: string[]);
    private b;
    get d(): string[];
    set d(a: string[]);
    private ad;
    get af(): any;
    set af(a: any);
    private w;
    get ab(): number;
    set ab(a: number);
    private t;
    get y(): number;
    set y(a: number);
    private u;
    get z(): number;
    set z(a: number);
    private v;
    get aa(): number;
    set aa(a: number);
    private x;
    get ac(): number;
    set ac(a: number);
    private f;
    get g(): PropertyEditorDescriptionObject;
    set g(a: PropertyEditorDescriptionObject);
    private h;
    get i(): PropertyEditorDescriptionObjectCollection;
    set i(a: PropertyEditorDescriptionObjectCollection);
    private l;
    get m(): PropertyEditorPropertyDescriptionCollection;
    set m(a: PropertyEditorPropertyDescriptionCollection);
    e: PropertyEditorDataSource;
    private aq;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    r(a: PropertyEditorPropertyDescription): boolean;
    ae(a: string, b: boolean): any;
    ap(): void;
    ao(): void;
    buttonClicked: (sender: any, args: PropertyEditorPropertyDescriptionButtonClickEventArgs) => void;
    changed: (sender: any, args: PropertyEditorPropertyDescriptionChangedEventArgs) => void;
    targetPropertyUpdating: (sender: any, args: PropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgs) => void;
    ar(a: string, b: any, c: any): void;
}
/**
 * @hidden
 */
export declare class PropertyEditorPropertyDescriptionCollection extends ObservableCollection$1<PropertyEditorPropertyDescription> {
    static $t: Type;
    constructor();
}
/**
 * @hidden
 */
export declare class PropertyEditorDataSource extends Base implements INotifyPropertyChanged {
    static $t: Type;
    private k;
    get n(): string;
    set n(a: string);
    private a;
    get b(): TypeDescriptionContext;
    set b(a: TypeDescriptionContext);
    private g;
    get h(): PropertyEditorPropertyDescriptionCollection;
    set h(a: PropertyEditorPropertyDescriptionCollection);
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    protected p(a: string, b: any, c: any): void;
    protected q(a: string, b: any, c: any): void;
    static d(a: TypeDescriptionContext, b: string, c: Dictionary$2<string, PropertyEditorDataSource>): PropertyEditorDataSource;
    private j;
    private f;
    private i;
    private r;
    e(a: string, b: boolean): PropertyEditorPropertyDescription;
    private c;
}
/**
 * @hidden
 */
export declare class PropertyEditorDescriptionObject extends Base {
    static $t: Type;
    b: string;
    a: PropertyEditorPropertyDescriptionCollection;
}
/**
 * @hidden
 */
export declare class PropertyEditorDescriptionObjectCollection extends ObservableCollection$1<PropertyEditorDescriptionObject> {
    static $t: Type;
    constructor();
}
