import { IgrPropertyEditorPropertyDescriptionCollection } from "./igr-property-editor-property-description-collection";
import { PropertyEditorDescriptionObject as PropertyEditorDescriptionObject_internal } from "./PropertyEditorDescriptionObject";
import { ContentChildrenManager } from "igniteui-react-core";
export declare class IgrPropertyEditorDescriptionObject {
    protected createImplementation(): PropertyEditorDescriptionObject_internal;
    protected _implementation: any;
    protected mounted: boolean;
    get nativeElement(): HTMLElement;
    /**
     * @hidden
     */
    get i(): PropertyEditorDescriptionObject_internal;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    get descriptionType(): string;
    set descriptionType(v: string);
    private _properties;
    get properties(): IgrPropertyEditorPropertyDescriptionCollection;
    set properties(v: IgrPropertyEditorPropertyDescriptionCollection);
    findByName(name: string): any;
}
